#ifndef	_NGTX_FEATURES_H
#define _NGTX_FEATURES_H 1

/* derived from RHEL 6 features.h */

#ifndef __APPLE__
#include "/usr/include/features.h"
#else

/* Undefine everything, so we get a clean slate.  */
#undef __USE_ISOC99
#undef __USE_ISOC95
#undef __USE_POSIX
#undef __USE_POSIX2
#undef __USE_POSIX199309
#undef __USE_POSIX199506
#undef __USE_XOPEN
#undef __USE_XOPEN_EXTENDED
#undef __USE_UNIX98
#undef __USE_XOPEN2K
#undef __USE_XOPEN2KXSI
#undef __USE_XOPEN2K8
#undef __USE_XOPEN2K8XSI
#undef __USE_LARGEFILE
#undef __USE_LARGEFILE64
#undef __USE_FILE_OFFSET64
#undef __USE_BSD
#undef __USE_SVID
#undef __USE_MISC
#undef __USE_ATFILE
#undef __USE_GNU
#undef __USE_REENTRANT
#undef __USE_FORTIFY_LEVEL

/* we don't use conditionals, undef others, too */
#undef _ISOC95_SOURCE
#undef _ISOC99_SOURCE
#undef _POSIX_SOURCE
#undef _POSIX_C_SOURCE
#undef _XOPEN_SOURCE
#undef _XOPEN_SOURCE_EXTENDED
#undef _LARGEFILE64_SOURCE
#undef _LARGEFILE_SOURCE
#undef _BSD_SOURCE
#undef _SVID_SOURCE
#undef _ATFILE_SOURCE
#undef _FILE_OFFSET_BITS
#undef __STDC_ISO_10646__



/* Always use ISO C things.  */
#define __USE_ANSI 1

/* Convenience macros to test the versions of glibc and gcc.
   Use them like this:
   #if __GNUC_PREREQ (2,8)
   ... code requiring gcc 2.8 or later ...
   #endif
   Note - they won't work for gcc1 or glibc1, since the _MINOR macros
   were not defined then.  */
#if defined __GNUC__ && defined __GNUC_MINOR__
# define __GNUC_PREREQ(maj, min) \
	((__GNUC__ << 16) + __GNUC_MINOR__ >= ((maj) << 16) + (min))
#else
# define __GNUC_PREREQ(maj, min) 0
#endif


/* defines like _GNU_SOURCE */
#define _ISOC95_SOURCE 1
#define __USE_ISOC95 1
#define _ISOC99_SOURCE 1
#define __USE_ISOC99 1
#define __STDC_ISO_10646__ 200009L
#define _POSIX_SOURCE 1
/* take care of Darwin 8! */
#define _POSIX_C_SOURCE	200809L

#define _LARGEFILE64_SOURCE 1
#define _LARGEFILE_SOURCE 1
#define __USE_LARGEFILE 1
#define __USE_LARGEFILE64 1

#define _BSD_SOURCE 1
#define __USE_BSD 1

#define __USE_MISC 1

/* try SV :-) */
#define __USE_SVID 1
#define _SVID_SOURCE 1

#define _ATFILE_SOURCE 1
#define __USE_ATFILE 1

#define __USE_POSIX199506 1
#define __USE_POSIX2 1
#define __USE_POSIX 1
#define __USE_POSIX199309 1

#define _XOPEN_SOURCE 700
#define _XOPEN_SOURCE_EXTENDED 1

#define __USE_XOPEN 1
#define __USE_XOPEN2K 1
#define __USE_XOPEN2KXSI 1
#define __USE_XOPEN2K8 1
#define __USE_XOPEN2K8XSI 1
#define __USE_XOPEN_EXTENDED 1

/*
#define __USE_POSIX_IMPLICITLY 1
*/

#define __USE_UNIX98 1

#define _FILE_OFFSET_BITS 64
#define __USE_FILE_OFFSET64 1

#define __USE_GNU 1

#if defined _REENTRANT || defined _THREAD_SAFE
# define __USE_REENTRANT 1
#endif

#if defined _FORTIFY_SOURCE && _FORTIFY_SOURCE > 0 \
    && defined __OPTIMIZE__ && __OPTIMIZE__ > 0
# if !__GNUC_PREREQ (4, 1)
#  ifdef __GNUC_RH_RELEASE__
#   warning _FORTIFY_SOURCE supported only with GCC 4.1 and later
#  endif
#  define __USE_FORTIFY_LEVEL 0
# elif _FORTIFY_SOURCE > 1
#  define __USE_FORTIFY_LEVEL 2
# else
#  define __USE_FORTIFY_LEVEL 1
# endif
#else
# define __USE_FORTIFY_LEVEL 0
#endif

/* We do support the IEC 559 math functionality, real and complex.  */
#define __STDC_IEC_559__ 1
#define __STDC_IEC_559_COMPLEX__ 1

/* Decide whether we can define 'extern inline' functions in headers.  */
#if __GNUC_PREREQ (2, 7) && defined __OPTIMIZE__ \
    && !defined __OPTIMIZE_SIZE__ && !defined __NO_INLINE__ \
    && defined __extern_inline
# define __USE_EXTERN_INLINES 1
#endif

#endif /* APPLE */

#endif
