#include "knoerre.h"

/*
 * $Id: check_error_exit.c 691 2017-06-04 23:12:04Z fwbergm $
 */

/**
 * Common do_check_* error exit
 *
 *
 * @param ret The program's exit code.
 */
void check_error_exit(int ret) {
  register char *p;

  p = stpcpy(knoerre_global_buf_cursor, ERROR_COMMON_VALUE_STRING);
  write1(knoerre_global_buf, p - knoerre_global_buf);
  _exit(ret);
}

#ifdef NULLDEF
/**
 * do_check_* error exit with debug output
 *
 *
 * @param buf The http data buf for returning data.
 * @param buflen The size of the http data buf.
 * @param ret The program's exit code.
 */
void check_error_exit_ns(register char *buf, const int buflen, int ret, uint32_t errcode, char *errstring, char *errfile) {
  register char *p;

  p = stpcpy(buf, str200);
  p = sputlongs(p, errcode);
  if (errstring != 0) {
    --p; *p = ' ';
    p = stpcpy(++p, errstring);
    *p = '\n'; ++p;
  }
  if (errfile != 0) {
    --p; *p = ' ';
    p = stpcpy(++p, errfile);
    *p = '\n'; ++p;
  }
  p = stpcpy(p, ERROR_COMMON_VALUE_STRING);
  write1(buf, p-buf);
  exit(ret);
}
#endif
