#ifdef KNOERRED
#include "knoerred.h"
#else
#include "knoerre.h"
#endif
#ifdef CONFIG_KNOERRE_CHECK_DUMMY
#ifndef CONFIG_KNOERRE_PROC_ACCESS
#error PROC_ACCESS needed for this check
#endif

/*
config KNOERRE_CHECK_DUMMY
    bool "check_dummy"
    default n
    depends on KNOERRE_PROC_ACCESS
    help
      This knoerre module just write out the uptime.
      It needs PROC_ACCESS. More information offers man-page knoerre(1).
      It is just a demo and a template for new check modules.
      You should say "N".

config KNOERRE_CHECK_DUMMY_KEY
    string "key string for check_dummy"
    default "dummy "
    depends on KNOERRE_CHECK_DUMMY
    help
      The key string for check_dummy as described in man-page knoerre(1).
      The trailing space is used as terminator to distinguish between "foo" and "foo/bar".
*/

/**
 * This is a demo function.
 *
 * This function is called by knoerre/knoerred main().
 * It's just a demo function which can be used
 * as a base code for a new check.
 * In order to write *something* out it writes
 * the uptime in seconds.
 * $Id: do_check_dummy.c 691 2017-06-04 23:12:04Z fwbergm $
 *
 * @return size of data to be sent, 0 on error
 */
int do_check_dummy() {
  register char *p;
  int i;
  ssize_t s;

  i = open("/proc/uptime", O_RDONLY);
  if (__unlikely(i < 0)) goto error;

  /* start output at this cursor, see knoerre.h */
  p = knoerre_global_buf_cursor;

  /* copy key (argv[1]) to output buffer */
  p = stpcpy(p, knoerre_global_arg1);
  --p; /* now points to space char after key string */
  *p = '\n'; ++p;

  /* avoid buffer overflow, read up to bufsize minus small offset */
  s = read(i, p, knoerre_global_bufsize - 100);
  close(i);
  if (__unlikely(s < 2)) goto error;

  p[s] = 0;
  for (;;) {
    /* break on dot */
    if (*p < '0') break; ++p;
  }
  *p = '\n'; ++p;

  /**
   * with knoerred we return the size of the output to the daemon,
   * with knoerre we end up here with execution of the process
   */
#ifdef KNOERRED
  return p - knoerre_global_buf;
#else
  write(1, knoerre_global_buf, p - knoerre_global_buf);
  _exit(0);
#endif

  error:
#ifndef KNOERRED
  check_error_exit(0);
#endif
  return 0;
}
#endif
