#ifdef KNOERRED
#include "knoerred.h"
#else
#include "knoerre.h"
#endif
#ifdef CONFIG_KNOERRE_CHECK_TIMEDIFF

/*
config KNOERRE_CHECK_TIMEDIFF
    bool "check_timediff"
    default y
    help
      This knoerre module shows the system time difference between local and remote host in seconds.
      More information offers man-page knoerre(1).

config KNOERRE_CHECK_TIMEDIFF_KEY
    string "key string for check_timediff"
    default "timediff/"
    depends on KNOERRE_CHECK_TIMEDIFF
    help
      The key string for check_timediff as described in man-page knoerre(1).
*/

/**
 * Return timediff to given seconds.
 *
 * This function is called by knoerre main().
 * As parm after "/timediff/" the current time
 * of the requesting server is given (seconds since 1970-01-01).
 *
 * @param buf The http data buf for returning data.
 * @param buflen The size of the http data buf.
 * @param bufp The pointer to char after http-header in buf.
 * @param arg1 The file/directory which lines to count
 */
int do_check_timediff(register char *buf, const int buflen, char *bufp, char *arg1) {
  register char *p;
  register time_t tp,tnow;
  uint64_t i;

  if (!str2uint64(arg1, &i)) goto error;
  tp = (time_t) i;

  tnow = time(NULL);
  tp = tnow - tp;
  if (tp < 0) tp = 0 - tp;

  p = stpcpy(bufp, arg1);
  --p; *p++ = '\n';
  p = sputlongs(p, tnow);
  p = sputlongs(p, tp);
#ifdef KNOERRED
  return p - buf;
#endif
  write1(buf, p-buf);
  _exit(0);

  error:
#ifdef KNOERRED
  return 0;
#endif
  p = stpcpy(bufp, ERROR_COMMON_VALUE_STRING);
  write1(buf, p-buf);
  _exit(1);
  return 0;
}
#endif
