#ifdef KNOERRED
#include "knoerred.h"
#else
#include "knoerre.h"
#endif
#undef KERNEL_BAD_ENTRIES
#ifdef CONFIG_KNOERRE_CHECK_DMESG
#define CONFIG_KERNEL_BAD_ENTRIES
#endif
#ifdef CONFIG_KNOERRE_CHECK_KERNELLOG
#define CONFIG_KERNEL_BAD_ENTRIES
#endif
#ifdef CONFIG_KERNEL_BAD_ENTRIES

/**
 * "Bad" strings and their weight in kernel-log/dmesg.
 *
 * These strings are some "bad" strings that nobody wants
 * to have in his kernel-log.
 * The more bad the log-entry is the higher is its weight.
 * These strings are actually strings and no regex's.
 * This list has to be extended.
 */
const KLE kernel_bad_entries[] = {
  { "Hardware Error", 2000 },
  { "kernel BUG", 1000 },
  { "kernel NULL pointer", 950 },
  { " data lost", 900 },
  { "Bad swap", 900 },
  { "unable to handle kernel paging", 900 },
  { "warning at kernel", 300 },
  { "nit degraded", 850 },
  { "rive error", 850 },
  { " path is down", 850 },
#ifndef NO_PAGE_ALLOC_ERROR
  { "page allocation failure", 10 },
#endif
  { "access beyond end of device", 850 },
  { "ector repair", 800 },
  { "resetting card", 300 },
  { "drain failed", 300 },
  { "bad entry in directory", 300 },
  { " Bad pte ", 300 },
  { "oom-killer", 300 },
  { "killing process", 300 },
  { " Unit Hang", 50 },
  { " segfault at ", 1 },
  { " reboot is needed", 100 },
  { "Neighbour table overflow", 800 },
/* dirtied inode on /proc/sys/vm/block_dump activated */
  { " dirtied inode ", 1 },
  { "Unrecovered read error", 300 },
  { "fs error", 500 },
  { "fs warning", 100 },
  { "Buffer I/O error", 300 },
  { "(media error)", 400 },
  { "sense key: Medium Error", 400 },
  { "drive_cmd: error=", 400 },
  { "nfsd: too many", 200 },
  { 0, 0 }
};

#endif
