#ifndef _KNOERRED_H
#define _KNOERRED_H

/**
 * $Id: knoerred.h 691 2017-06-04 23:12:04Z fwbergm $
 */

#include "knoerre.h"
#include <sys/socket.h>
#include <arpa/inet.h>
#include <sched.h>

#ifndef CLONE_SYSVSEM
#define CLONE_SYSVSEM 0x00040000
#endif
#ifndef CLONE_IO
#define CLONE_IO 0x80000000
#endif

#define STACKSIZE 262144
#define DAEMON_NET_BUFSIZE 1448

extern int measure_cursor;
extern int measure_oldest;
extern uint64_t measure_timestamp[];
extern uint64_t measure_cpu_user[];
extern uint64_t measure_cpu_system[];
extern uint64_t measure_cpu_idle[];
extern uint64_t measure_cpu_wait[];
extern uint64_t measure_cpu_irq[];
extern uint64_t measure_cpu_softirq[];
extern uint64_t measure_ctxt[];
extern uint64_t measure_nettraf0recv[];
extern uint64_t measure_nettraf0send[];
extern uint64_t measure_nettraf1recv[];
extern uint64_t measure_nettraf1send[];
extern int cpu_user_percent[];
extern int cpu_system_percent[];
extern int cpu_idle_percent[];
extern int cpu_wait_percent[];
extern int cpu_irq_percent[];
extern int cpu_softirq_percent[];
extern uint32_t ctxt_switches_persecond[];
extern uint32_t nettraf0_kb_persecond[];
extern uint32_t nettraf1_kb_persecond[];
extern char hostname[][STRING_SIZE+1];
extern char loadavg[][STRING_SIZE+1];
extern char swaps[][STRING_SIZE+1];
extern struct statfs statfs_root[];
extern int statfs_root_err[];
extern FS_STAT fsstat_top[];
extern int netlinksdown[];
extern char multiresults[][DAEMON_NET_BUFSIZE+1];

extern int current_values_cursor;

// #ifdef __dietlibc__
// int *interval_measure(void *notused);
// #else
int interval_measure(void *notused);
// #endif
void record_measure_values();
void record_multi_values(int tmpcursor);

#endif
