#include "buffer.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#define BUF_SIZE 65536

/**
 * $Id: buffer_catfromfile.c 691 2017-06-04 23:12:04Z fwbergm $
 */

int buffer_catfromfile(buffer *b, char *filename) {
  register int c = -1;
  char buf[BUF_SIZE+1];
  register int bytes_read;
  int ret_value = -1;

  if (!filename) return c;
  if (!*filename) return c;

  c = open(filename, O_RDONLY);
  if (c == -1) return c;

  for (;;) {
    bytes_read = read(c, buf, BUF_SIZE);
    if (bytes_read == -1) goto out;
    if (bytes_read == 0) break;
    if (buffer_putmem(b, buf, bytes_read) == -1) goto out;
  }
  ret_value = 0;

  out:
  (void) close(c);
  return ret_value;
}

