#include "buffer.h"

/**
 * $Id: buffer_flush.c 691 2017-06-04 23:12:04Z fwbergm $
 */

int buffer_flush(buffer *b) {
  register char *p;
  ssize_t bytes;

  if (!b) return 1;
  if (b->l > 0) return 1; /* read buffer */
  p = b->s;
  if (p == b->c) return 0;
  for (;;) {
    bytes = write(b->fd, p, b->c - p);
    if (bytes == -1) return 1;
    p += bytes;
    if (p == b->c) break;
  }
  b->c = b->s;
  return 0;
}
