#include "buffer.h"

/**
 * $Id: buffer_getline.c 691 2017-06-04 23:12:04Z fwbergm $
 */

int buffer_getline(buffer *b, char *str, int str_size) {
  register int c;
  char *buf = str;

  if (!b) return EOF;

  if (str_size <= 0) goto out;
  c = buffer_getchar(b);
  if (c < 0) return c;
  if (c == '\r') c = buffer_getchar(b);

  for (;;) {
    if (c < 0) return c;
    if (c == '\n') goto out;
    *str = c; ++str; *str = 0; --str_size;
    if (str_size <= 0) goto out;
    c = buffer_getchar(b);
  }

  out:
  return (int) (str - buf);
}

