#include "buffer.h"

/**
 * $Id: buffer_put.c 691 2017-06-04 23:12:04Z fwbergm $
 */

int buffer_put(buffer *b, register const char *a, register uint32_t l) {
  register char *p;
  register char *s;
  register const char *t;

  if (!l) return 0;
  if (!b) return -1;
  p = b->c;
  t = b->t;
  if ((p + l) <= t) goto put;

  s = b->s;
  if (write(b->fd, s, p-s) < 0) return -1;
  p = s;
  if ((p + l) > t) {
    b->c = p;
    return write(b->fd, a, l);
  }

  put:
  t = a + l;
  for(;;) {
    *p = *a; ++p; ++a; if (a >= t) break;
    *p = *a; ++p; ++a; if (a >= t) break;
    *p = *a; ++p; ++a; if (a >= t) break;
    *p = *a; ++p; ++a; if (a >= t) break;
  }
  b->c = p;
  return 0;
}
