#include "libfwb.h"

/**
 * Return index to a field in a string.
 *
 * This is a helper function for do_check_longuserprocesses() and more.
 * It searches a string for a field specified by number
 * 'index' and returns the string index position.
 * One space (" ") is taken as field separator.
 * If the end of the string is reached without finding
 * field number 'index' then -1 is returned.
 *
 * $Id: field_index.c 691 2017-06-04 23:12:04Z fwbergm $
 *
 * @param s The string to be searched through.
 * @param index The number of the field index to search for.
 * @return The index position of the field in the string or -1 on error.
 */
int32_t field_index(const char *s,int index) {
  register const char* t = s;

  if (!t) return 0;
  if (index < 1) return 0;
  for (;;) {
    if (!*t) return -1; if (*t == ' ') { --index; if (!index) { ++t; return t - s; } } ++t;
    if (!*t) return -1; if (*t == ' ') { --index; if (!index) { ++t; return t - s; } } ++t;
    if (!*t) return -1; if (*t == ' ') { --index; if (!index) { ++t; return t - s; } } ++t;
    if (!*t) return -1; if (*t == ' ') { --index; if (!index) { ++t; return t - s; } } ++t;
  }
}
