/*
 * lib/get_name_from_passwd.c
 * FWB www.tuxad.com
 *
 * $Id: get_name_from_passwd.c 691 2017-06-04 23:12:04Z fwbergm $
 */

#include <stdint.h>
#include <string.h>
#include "libfwb.h"

const char *get_name_from_passwd(const char *pwdbuf, off_t pwdlen, uint32_t uid, int *username_len) {
  register char *p;
  char *s;
  char uid_s[12];
  int uid_s_len;
  const char *t = pwdbuf + pwdlen;

  if ((!pwdbuf) || (!username_len)) return 0;
  p = sputuint32(uid_s, uid);
  *p = ':'; ++p;
  uid_s_len = p - uid_s;

  for(;;) {
    s = strchr(pwdbuf, ':');
    if (!s) return 0;
    ++s;
    p = strchr(s, ':');
    if (!p) return 0;
    ++p;
    if (!strncmp(p, uid_s, uid_s_len)) {
      *username_len = s - pwdbuf - 1;
      return pwdbuf;
    }
    p = memchr(p, '\n', t-p);
    if (!p) return 0;
    ++p;
    for(;*p == '\n';++p); /* broken passwd files */
    pwdbuf = p;
  }
}
