/*
 * lib/get_uid_from_passwd.c
 * FWB www.tuxad.com
 *
 * $Id: get_uid_from_passwd.c 691 2017-06-04 23:12:04Z fwbergm $
 */

#include "libfwb.h"

const char *get_uid_from_passwd(register const char *pwdbuf, off_t pwdlen, const char *username, int username_len, int *uid_len) {
  const char *t = pwdbuf + pwdlen;

  if ((!pwdbuf) || (!username) || (!uid_len)) return 0;
  for(;;) {
    if (!strncmp(pwdbuf, username, username_len)) {
      pwdbuf += username_len;
      if (*pwdbuf == ':') break;
    }
    pwdbuf = memchr(pwdbuf, '\n', t-pwdbuf);
    if (!pwdbuf) return 0;
    ++pwdbuf;
  }
  ++pwdbuf;
  pwdbuf = strchr(pwdbuf, ':');
  if (!pwdbuf) return 0;
  ++pwdbuf;
  t = strchr(pwdbuf, ':');
  if (!t) return 0;
  *uid_len = (int) (t - pwdbuf);
  return pwdbuf;
}
