#include "libfwb.h"

/**
 * Write a uint32_t into a string buffer.
 *
 * WARNING: No boundary checks are made!
 *
 * $Id: sputuint32.c 691 2017-06-04 23:12:04Z fwbergm $
 *
 * @param buf The buffer to write the decimal number in.
 * @param num The number to write in the buffer.
 * @return The pointer to the string terminating null char.
 */
char *sputuint32(char *buf, uint32_t i) {
  register char *pbuf;
  register int c;
  uint32_t d;
  int o;

  if (!buf) return 0;
  o = 0; pbuf = buf;
  for (d = 1000000000; d > 1; d /= 10) {
    c = i / d;
    if ((c > 0) || (o)) {
      *pbuf = c + '0';
      ++pbuf;
      i = i - (c * d);
      o = 1;
    }
  }
  *pbuf = i + '0'; ++pbuf;
  *pbuf = 0;
  return pbuf;
}
