#include "libfwb.h"

/**
 * Append a string to a string.
 *
 * Append a string to a string without boundary checks.
 *
 * $Id: str_cat.c 691 2017-06-04 23:12:04Z fwbergm $
 *
 * @param out The string to grow.
 * @param in The string to be appended.
 * @return The len of the enlarged string.
 */
uint32_t str_cat(char* out, const char* in) {
  register char* s = out;
  register uint32_t i;

  if ((!s) || (!in)) return 0;
  i = 0;
  for (;;) {
    if (!s[i]) break; ++i;
    if (!s[i]) break; ++i;
    if (!s[i]) break; ++i;
    if (!s[i]) break; ++i;
    if (!s[i]) break; ++i;
    if (!s[i]) break; ++i;
    if (!s[i]) break; ++i;
    if (!s[i]) break; ++i;
  }
  s += i;
  for (;;) {
    if (!*in) break; *s = *in; ++s; ++in;
    if (!*in) break; *s = *in; ++s; ++in;
    if (!*in) break; *s = *in; ++s; ++in;
    if (!*in) break; *s = *in; ++s; ++in;
  }
  *s = 0;
  return (uint32_t) (s - out);
}
