#include "libfwb.h"

/**
 * Append a string to a string.
 *
 * Append the second given string after the first string.
 * Only maximum "limit" chars will be appended.
 *
 * $Id: str_catn.c 691 2017-06-04 23:12:04Z fwbergm $
 *
 * @param out The string to be grow.
 * @param in The string to be appended.
 * @param limit The maximum number of chars to be appended.
 * @return The len of the enlarged string.
 */
uint32_t str_catn(char *out,register const char *in, uint32_t limit) {
  register char* s = out;
  register const char* u = in + limit;

  if ((!s) || (!in)) return 0;
  for (;;) {
    if (!*s) break; ++s;
    if (!*s) break; ++s;
    if (!*s) break; ++s;
    if (!*s) break; ++s;
  }
  for (;;) {
    if (in >= u) { *s = 0; break; } if (!(*s = *in)) break; ++s; ++in;
    if (in >= u) { *s = 0; break; } if (!(*s = *in)) break; ++s; ++in;
    if (in >= u) { *s = 0; break; } if (!(*s = *in)) break; ++s; ++in;
    if (in >= u) { *s = 0; break; } if (!(*s = *in)) break; ++s; ++in;
  }
  return (uint32_t) (s - out);
}
