#include "libfwb.h"

/**
 * Compare two strings from the ends
 *
 * It compares all chars of the second string at the end of the first string.
 * Common usage is i.e. testing if a filename ends with ".gif".
 * Example: str_diff_right(filename, ".gif")
 *
 * $Id: str_diff_right.c 691 2017-06-04 23:12:04Z fwbergm $
 *
 * @param u The first string.
 * @param v The second string.
 * @return 0 if strings are equal.
 */
int str_diff_right(const char *u, const char *v) {
  register const char *s;
  register const char *t;
  register int j;
  register int m,n;

  if ((!u) || (!v)) return 1;
  m = strlen(u); n = strlen(v);
  if (m < n) return -1;
  s = u + m - n;
  t = v;
  for(;;) {
    j = (*s - *t); if (j) break; if (!*t) break; if (!*s) break; ++s; ++t;
    j = (*s - *t); if (j) break; if (!*t) break; if (!*s) break; ++s; ++t;
    j = (*s - *t); if (j) break; if (!*t) break; if (!*s) break; ++s; ++t;
    j = (*s - *t); if (j) break; if (!*t) break; if (!*s) break; ++s; ++t;
  }
  return j;
}

