#include "libfwb.h"

/**
 * Compare two strings
 *
 * It compares all chars or up to "limit" chars of two strings.
 * It's an alternative version of strncmp().
 *
 * $Id: str_diffn.c 691 2017-06-04 23:12:04Z fwbergm $
 *
 * @param s The first string.
 * @param t The second string.
 * @param limit The max number of chars to compare.
 * @return 0 if strings are equal.
 */
int str_diffn(register const char* s, register const char* t, uint32_t limit) {
  register const char* u;
  register int j;

  if ((!s) || (!t)) return 1;
  u = t + limit;
  j = 0;
  for (;;) {
    if (t >= u) break; j = (*s - *t); if (j) break; if (!*t) break; ++s; ++t;
    if (t >= u) break; j = (*s - *t); if (j) break; if (!*t) break; ++s; ++t;
    if (t >= u) break; j = (*s - *t); if (j) break; if (!*t) break; ++s; ++t;
    if (t >= u) break; j = (*s - *t); if (j) break; if (!*t) break; ++s; ++t;
  }
  return j;
}
