#include "libfwb.h"

/**
 * $Id: write2file.c 691 2017-06-04 23:12:04Z fwbergm $
 */

/**
 * write a string (i.e. one "line") to a file.
 *
 * @param filename The name of the file the string should be written to.
 * @param str The string to be written to file.
 * @param len The len of the str to be written. On -1 strlen() will be called to caluculate.
 * @return -1 on error. 0 if not len bytes were written. On success return len.
 */
int write2file(const char *filename, register const char *str, register int len) {
  register int c = -1;
  register int written;

  if (!filename) return c;
  if (!*filename) return c;
  if (!str) return c;
  
  c = open(filename, O_WRONLY | O_CREAT, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH );

  if (c == -1) return c;

  if (len == -1) len = strlen(str);
  written = write(c, str, len);
  (void) close(c);

  if (written < 1) return written;
  if (written != len) written = 0;
  return written;
}

