#include <stdlib.h>
#include <errno.h>

/**
 * PD by Daniel J. Bernstein:
 * alloc()/alloc_free()
 * alloc_free is not used, cleanup will be done on unmount
 */
#define ALIGNMENT 16 /* XXX: assuming that this alignment is enough */
#define SPACE 819200 /* must be multiple of ALIGNMENT */

typedef union { char irrelevant[ALIGNMENT]; double d; } aligned;
static aligned realspace[SPACE / ALIGNMENT];
#define space ((char *) realspace)
static unsigned int avail = SPACE; /* multiple of ALIGNMENT; 0<=avail<=SPACE */

void *alloc(size_t n) {
  char *x;
  n = ALIGNMENT + n - (n & (ALIGNMENT - 1)); /* XXX: could overflow */
  if (n <= avail) { avail -= n; return space + avail; }
  x = malloc(n);
  /* if (!x) errno = error_nomem; */
  if (!x) errno = 127;
  return x;
}
