#include "monitoringfs.h"

void count_dir_entries(KD *start, uint16_t countparentdot) {
  uint16_t count;
  KD *e;
  KD *dot;
  KD *dotdot;

  count = 2;
  dot = dotdot = 0;
  if (start) {
    e = start;
  } else {
    e = &keyroot;
  }
  /* count all dirs in current dir */
  for (;;) {
    if (!e) break;
    if (dot || strcmp(e->entry, ".")) {
      if (dotdot || strcmp(e->entry, "..")) {
        if (e->subdir) ++count;
      } else {
        dotdot = e;
      }
    } else {
      dot = e;
    }
    e = e->next;
  }
  if (!dot) return;
  dot->lnk_count = count;
  if (!dotdot) return;
  e = dotdot;
  e->lnk_count = countparentdot;
  e = e->next;
  /* recursively count links in subdirs */
  for (;;) {
    if (!e) break;
    if (e->subdir) count_dir_entries(e->subdir, count);
    e = e->next;
  }
  return;
}

