#include "monitoringfs.h"

int monitoringfs_open(const char *path, struct fuse_file_info *fi) {
  register char *p;
  int h;
  KD *kd;

  if((fi->flags & 3) != O_RDONLY)
    return -EACCES;

  ++path;

  h = 0;
  for(;;) {
    int hlen;

    next_host:
    p = (char *) monitoringfs_hosts[h];
    if (!p) return -ENOENT;

    /* host-dir */
    hlen = strlen(p);
    if (!strncmp(path, p, hlen)) {
      p = (char *) path + hlen;
      if (!*p) return -EISDIR;
      if (*p != '/') { ++h; goto next_host; }
      ++p;
      if (!*p) return -EISDIR;

      /* now points to key-dir */
      kd = search_kd_entry(p, 0, 0);
      if (!kd) return -ENOENT;
      if (kd->is_dir || kd->subdir) return -EISDIR;
      return 0;
    }
    
    ++h;
  }

  return -ENOENT;
}
