#include "monitoringfs.h"

int monitoringfs_read(const char *path, char *buf, size_t size, off_t offset,
                      struct fuse_file_info *fi) {
  register char *p;
  int h;
  size_t len;
  (void) fi;
  KD *kd;

  /**
   * no offset support!
   * every new read() call will read from position 0
   */
  if (offset) return 0;

  ++path;

  h = 0;
  for(;;) {
    int hlen;

    next_host:
    p = (char *) monitoringfs_hosts[h];
    if (!p) return -ENOENT;

    /* host-dir */
    hlen = strlen(p);
    if (!strncmp(path, p, hlen)) {
      p = (char *) path + hlen;
      if (!*p) return -ENOENT;
      if (*p != '/') { ++h; goto next_host; }
      ++p;
      if (!*p) return -ENOENT;

      /* now points to key-dir */
      kd = search_kd_entry(p, 0, 0);
      if (!kd) return -ENOENT;
      if (kd->is_dir || kd->subdir) return -EISDIR;
      size -= 2;
#ifdef MONITORINGFSHTTP
      len = monitoringfs_get_remote_by_http(monitoringfs_ipaddresses[h], p, buf, size);
#else
      len = monitoringfs_get_remote_by_udp(monitoringfs_ipaddresses[h], p, buf, size);
#endif
      if (!len) return 0;
      p = buf + len - 1;
      if (*p != '\n') {
        ++p; *p = '\n';
        ++p; *p = 0;
        ++len;
      }
      return len;
    }

    ++h;
  }

  return -ENOENT;
}
