#include "monitoringfs.h"

int monitoringfs_readdir(const char *path, void *buf, fuse_fill_dir_t filler,
                         off_t offset, struct fuse_file_info *fi) {
  register char *p;
  int i;
  (void) offset;
  (void) fi;
  KD *kd;

  if(!strcmp(path, "/")) {
    filler(buf, ".", NULL, 0);
    filler(buf, "..", NULL, 0);
    i = 0;
    for(;;) {
      p = (char *) monitoringfs_hosts[i];
      if (!p) break;
      filler(buf, p, NULL, 0);
      ++i;
    }
    return 0;
  }

  ++path;
  for (;;) {
    if (!*path) { kd = &keyroot; goto step_dir; }
    if (*path == '/') break;
    ++path;
  }
  ++path;

  kd = search_kd_entry(path, 0, 0);
  if (!kd) return -ENOENT;
  kd = kd->subdir;
  if (!kd) return -ENOENT;

  step_dir:
  for (;;) {
    filler(buf, kd->entry, 0, 0);
    kd = kd->next;
    if (!kd) break;
  }
  return 0;
}
