#include "monitoringfs.h"

KD *search_kd_dir(const char *kdirpath, KD *start, int insert) {
  register char *p;
  char *r;
  KD *e;
  KD *last_entry;
  char oneentry[STRINGSIZE + 1];
  char onepath[STRINGSIZE + 1];

  if (!kdirpath) return 0;
  if (start) {
    e = start;
  } else {
    e = &keyroot;
  }
  p = (char *) kdirpath;
  for (;;) {
    r = p;
    p = strchr(p, '/');
    if (!p) break;
    strncpy(onepath, kdirpath, p - kdirpath);
    onepath[p - kdirpath] = 0;
    strncpy(oneentry, r, p - r);
    oneentry[p - r] = 0;
    e = search_kd_direntry(oneentry, e, &last_entry);
    if (!e) {
      if (insert) e = insert_kd_dir(last_entry, onepath, oneentry);
      if (!e) return 0;
    }
    e = e->subdir;
    if (!e) return 0;
    ++p;
  }
  for (;;) {
    if (!strcmp(kdirpath, e->fullpath)) return e->subdir;
    /* *last_entry = e; */
    if (!e->next) {
      e = insert_kd_dir(e, kdirpath, r);
      if (!e) return 0;
    } else e = e->next;
  }
  return 0;
}
