#!/bin/bash

# /etc/nagios-cache.d/base-updates.sh
# $Id: base-updates.sh 691 2017-06-04 23:12:04Z fwbergm $


test -e /etc/nagios-cache.d/.ncrc || { echo "ERROR: no /etc/nagios-cache.d/.ncrc found" | tee /dev/stderr; exit 1; }
. /etc/nagios-cache.d/.ncrc


# check if knoerre or others were updated and copy new versions
{
mkdir -p bin
chmod -R go-rwx .
chgrp clamav .
chmod 710 .
chmod 755 bin
# be paranoid 'bout knoerre
chmod 500 bin/knoerre
( umask 077; cmp /opt/nagios-fwb/bin/knoerre /nagios-cache/bin/knoerre >/dev/null 2>&1 || /bin/cp -dRf --preserve=ownership,timestamps /opt/nagios-fwb/bin/knoerre /nagios-cache/bin/knoerre; )
chmod 500 bin/knoerre
mkdir -p clamav; chown clamav:clamav clamav;chmod 710 clamav
} 2>/dev/null
for f in \
  cacti_remote_by_http \
  check_http_fwb \
  check_remote_by_http \
  check_remote_by_http_time \
  daemonize \
  direntries \
  filescan \
  killwebprocs \
  lns \
  lps \
  lkill \
  msleep250 msleep500 msleep750 \
  postfix-mailqsize \
  sfgrep
do
  cmp /opt/nagios-fwb/bin/$f bin/$f >/dev/null 2>&1 || /bin/cp -af /opt/nagios-fwb/bin/$f bin/$f 2>/dev/null
  chmod 755 bin/$f 2>/dev/null
done
/bin/rm -f bin/killallphp 2>/dev/null;ln -s killwebprocs bin/killallphp 2>/dev/null
# this touch is essential!
touch bin/*


# create main subdirs
for f in \
  allsmart \
  cpusc/55 \
  cpuuc/55 \
  cpuwc/55 \
  grillkills \
  ipmi \
  ovm \
  process/syslog-ng \
  snmptraps/status \

do
  echo $f|grep -q "\/" && { DIR="${f%/*}"; mkdir -p "$DIR" 2>/dev/null; }
done


# don't allow files laying around here if check doesn't work anymore
find . -type f -mtime +7 -exec /bin/rm -f {} \; 2>/dev/null
find . -type f -mmin +2160 2>/dev/null |grep -v snmptraps |xargs /bin/rm -f 2>/dev/null
find . -type f -mmin +1800 2>/dev/null |egrep -v 'maxsizes|snmptraps|maxfilesizes|dirlevels' |xargs /bin/rm -f 2>/dev/null
find . -type d -mtime +2 -exec /bin/rmdir -p {} \; 2>/dev/null


# this is also essential
exit 0
