#!/bin/bash

# /etc/nagios-cache.d/daemons-ssh.sh
# $Id: daemons-ssh.sh 691 2017-06-04 23:12:04Z fwbergm $

# do some checks, set up environment, cd /nagios-cache :
test -e /etc/nagios-cache.d/.ncrc || { echo "ERROR: no /etc/nagios-cache.d/.ncrc found" | tee /dev/stderr; exit 1; }
. /etc/nagios-cache.d/.ncrc

KEY=process/sshd
ulimit -t 30
ulimit -i 1
TMPSUFFIX=$(date +%M)
KEYDIR=${KEY%/*}
[ "$KEY" = "$KEYDIR" ] && KEYDIR=.
mkdir -p $KEYDIR 2>/dev/null
KEYRESULT=$KEY
[ -d "$KEYRESULT" ] && KEYRESULT="$KEYRESULT"_
LOCKFILE="$KEYRESULT".lock

if [ -e $LOCKFILE ]
then
  # there's still a nc-process running
  echo 999999999999999997 >>$KEYRESULT
  AGE=$(($(date +%s)-$(date -r $LOCKFILE +%s 2>/dev/null || echo 0)))
  [ $AGE -gt 1800 ] && /bin/rm -f $LOCKFILE
  exit 0
fi

echo $$ >$LOCKFILE

knoerre $KEY >>$KEY.$TMPSUFFIX 2>/dev/null \
  || echo 999999999999999999 >>$KEY.$TMPSUFFIX
/bin/mv $KEY.$TMPSUFFIX $KEYRESULT 2>/dev/null

/bin/rm -f $LOCKFILE
exit 0
