#!/bin/bash

# /etc/nagios-cache.d/fsckage.sh
# $Id: fsckage.sh 691 2017-06-04 23:12:04Z fwbergm $
# filesystems check age

test -e /etc/nagios-cache.d/.ncrc || { echo "ERROR: no /etc/nagios-cache.d/.ncrc found" | tee /dev/stderr; exit 1; }
. /etc/nagios-cache.d/.ncrc

KEY=fsckage
TMPSUFFIX=$(date +%M)
KEYDIR=${KEY%/*}
[ "$KEY" != "$KEYDIR" ] && mkdir -p $KEYDIR 2>/dev/null

KEYRESULT=$KEY
[ -d "$KEYRESULT" ] && KEYRESULT="$KEYRESULT"_

{
MAXAGE=0
OLDESTFS=""
for f in $(mount|grep "^\/dev\/.*"|grep -v nagios-cache|cut -d\  -f1)
do
  TS=$(date +%s -d "$(tune2fs -l $f|grep "Last checked:"|cut -d: -f2-)")
  NOW=$(date +%s)
  AGE=$((($NOW - $TS)/86400))
  if [ "$AGE" -gt "$MAXAGE" ]
  then
    MAXAGE=$AGE
    OLDESTFS=$f
  fi
  echo $f $AGE days
done
echo $OLDESTFS
echo $MAXAGE
} >>$KEY.$TMPSUFFIX 2>/dev/null
RET=$?
/bin/mv $KEY.$TMPSUFFIX $KEYRESULT 2>/dev/null

exit $RET
