#!/bin/bash

# /etc/nagios-cache.d/ovm.sh
# $Id: ovm.sh 691 2017-06-04 23:12:04Z fwbergm $

# do some checks, set up environment, cd /nagios-cache :
test -e /etc/nagios-cache.d/.ncrc || { echo "ERROR: no /etc/nagios-cache.d/.ncrc found" | tee /dev/stderr; exit 1; }
. /etc/nagios-cache.d/.ncrc

# nagios-check "ovm"
KEY=ovm
ulimit -t 30
ulimit -i 1
# check master, too; set OVZ_CHECK_MASTER_ID and set it to 0:
OVZ_CHECK_MASTER_ID=0
TMPSUFFIX=$(date +%M)
KEYDIR=${KEY%/*}
[ "$KEY" = "$KEYDIR" ] && KEYDIR=.
mkdir -p $KEYDIR 2>/dev/null
KEYRESULT=$KEY
[ -d "$KEYRESULT" ] && KEYRESULT="$KEYRESULT"_
LOCKFILE="$KEYRESULT".lock

if [ -e $LOCKFILE ]
then
  # there's still a nc-process running
  echo 999999999999999997 >>$KEYRESULT
  AGE=$(($(date +%s)-$(date -r $LOCKFILE +%s 2>/dev/null || echo 0)))
  [ $AGE -gt 1800 ] && /bin/rm -f $LOCKFILE
  exit 0
fi

echo $$ >$LOCKFILE

# is host an OpenVZ master (CTID=0)?
if [ -d "$OVZ_PRIVATE_DIR" ]
then

  /bin/rm -f $KEY.$TMPSUFFIX
  touch $KEY.$TMPSUFFIX
  for f in $(cd "$OVZ_PRIVATE_DIR";ls)
  do
    ( . /etc/vz/conf/$f.conf; echo $HOSTNAME $IP_ADDRESS; ) >>$KEY.$TMPSUFFIX 2>/dev/null
  done
  /bin/mv $KEY.$TMPSUFFIX $KEYRESULT 2>/dev/null

fi

/bin/rm -f $LOCKFILE
exit 0
