#!/bin/bash

echo "don't run this script unless you know what you are doing"
exit 1

test -e /etc/nagios-cache.d/.ncrc || { echo "ERROR: no /etc/nagios-cache.d/.ncrc found" | tee /dev/stderr; exit 1; }
. /etc/nagios-cache.d/.ncrc

mkdir -p maxfilesizes/9 2>/dev/null
knoerre maxfilesizes/9/ >>maxfilesizes/9/home/www/@/html.0 2>/dev/null
RET=$?
/bin/mv maxfilesizes/9/home/www/@/html.0 maxfilesizes/9/home/www/@/html 2>/dev/null
exit $RET
#!/bin/bash

# /etc/nagios-cache.d/syslog.sh
# FWB 2009-08-11

# files in /nagios-cache :
# /nagios-cache/process/syslog-ng           result of the host itself
# /nagios-cache/vps/0/process/syslog-ng     if host is OpenVZ master (CTID=0) then this is a copy
# /nagios-cache/vps/1079/process/syslog-ng  result of virtual private server with CTID=1079
# /nagios-cache/vps/process/syslog-ng       summary/max result of all CTIDs (0 included)


# do some checks, set up environment, cd /nagios-cache :
test -e /etc/nagios-cache.d/.ncrc || { echo "ERROR: no /etc/nagios-cache.d/.ncrc found" | tee /dev/stderr; exit 1; }
. /etc/nagios-cache.d/.ncrc

# nagios-check "syslog"
KEY=process/syslog-ng

# check the host itself
KEYDIR=${KEY%/*}
mkdir -p $KEYDIR 2>/dev/null
knoerre $KEY >>$KEY.0 2>/dev/null \
  || echo 999999999999999999 >>$KEY.0
/bin/mv $KEY.0 $KEY 2>/dev/null

# is host an OpenVZ master (CTID=0)?
if [ -d "$OVZ_PRIVATE_DIR" ]
then

  # OpenVZ master: check all virtual private servers, too

  mkdir -p vps/0/$KEYDIR vps/$KEYDIR
  # don't copy master result, repeat check for CTID = 0
  #/bin/cp -af $KEY vps/0/$KEY
  OVZ0KEY=$(echo $KEY|sed 's,/,/OpenVZ-CTID_0/,')
  knoerre $OVZ0KEY >>vps/0/$KEY.0 2>/dev/null \
    || echo 999999999999999999 >>vps/0/$KEY.0
  /bin/mv vps/0/$KEY.0 vps/0/$KEY 2>/dev/null

  # collect results of all vps
  for f in $(cd "$OVZ_PRIVATE_DIR";ls)
  do
	mkdir -p vps/$f/$KEYDIR
	vzctl exec $f /opt/nagios-fwb/bin/knoerre $KEY >>vps/$f/$KEY.0 2>/dev/null \
      || echo 999999999999999999 >>vps/$f/$KEY.0
    /bin/mv vps/$f/$KEY.0 vps/$f/$KEY 2>/dev/null
  done

  # search for max result, include CTID=0
  RET=0
  for f in $(cd "$OVZ_PRIVATE_DIR";ls) 0
  do
    echo $f $(cat vps/$f/$KEY) >>vps/$KEY.0
	VALUE=$(tail -n 1 vps/$f/$KEY)
	# simple error check to catch integer-test-errors
	[ "$VALUE" -ge 0 ] 2>/dev/null || VALUE="999999999999999999"
	# new max value?
	[ "$VALUE" -gt "$RET" ] && RET=$VALUE
  done

  # print max of all results
  echo $RET >>vps/$KEY.0
  /bin/mv vps/$KEY.0 vps/$KEY 2>/dev/null

fi
