/*
 * nagios-check-backup.c
 * read backup timestamp YYYYMMDD from file and prints diff to now in hours
 * Frank Bergmann, 12/2007
 */

#define FILENAME "/var/log/backup.timestamp"

#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "../lib/libfwb.h"

#define SLEN 256

int main() {
  register char *p;
  register long tmp;
  int bak_year,bak_mon,bak_mday;
  char readbuf[SLEN+1];
  time_t tp,tnow;
  struct tm t;
  register int fd;

  p=readbuf;
  fd=open(FILENAME, O_RDONLY);
  if (fd == -1) goto error;
  tmp=read(fd, p, SLEN); close(fd);
  if (tmp<=0) goto error;
  p[tmp]='\0';
  bak_year=(*p++-'0')*1000; bak_year+=(*p++-'0')*100;
  bak_year+=(*p++-'0')*10; bak_year+=*p++-'0';
  bak_mon=(*p++-'0')*10; bak_mon+=*p++-'0';
  bak_mday=(*p++-'0')*10; bak_mday+=*p-'0';
  if((bak_year<2007)||(bak_year>2050)) goto error;
  if((bak_mon<0)||(bak_mon>12)) goto error;
  if((bak_mday<0)||(bak_mday>31)) goto error;

  tp = time(NULL);
  if (tp<10) goto error;
  tnow=tp;
  if(localtime_r(&tp,&t)==NULL) goto error;
  t.tm_year=bak_year-1900;
  t.tm_mon=bak_mon-1; t.tm_mday=bak_mday;
  t.tm_hour=22; t.tm_min=10;
  tp=mktime(&t);
  if(tp<0) goto error;
  tmp=(long)((tnow-tp)/3600);
  if(tmp<0) tmp+=23;
  if(tmp<0) tmp=0;
  putlong(tmp);
  _exit(0);

  error:
  write1("9999\n",5);
  _exit(1);
}
