/*
 * $Id: nagios-check-nfs.c 691 2017-06-04 23:12:04Z fwbergm $
 * nagios-check-nfs.c
 * checks NFS by CATing a file from a nfs-mounted fs
 *
 * Frank Bergmann, 12/2007
 */

#define _FILE_OFFSET_BITS 64
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <signal.h>
#include <string.h>
#include <setjmp.h>

#ifndef write1
#include <sys/syscall.h>
#define write1(b,c) (syscall(__NR_write, 1, b, c))
#endif
#ifndef write2
#include <sys/syscall.h>
#define write2(b,c) (syscall(__NR_write, 2, b, c))
#endif

#define SLEN 256
char filename[SLEN+1];
static const char msg[]="missing argument like: /var/kugelfisch/resources/.I_AM_ALIVE.DO_NOT_DELETE\n";

static jmp_buf check_procstate;

void sigchld_handler(int num) {
  longjmp(check_procstate,1);
/*
  register ssize_t bytes;
  register int fd;
  char p[SLEN+1];

  fd=open(filename, O_RDONLY);
  if (fd == -1) goto errexit;
  bytes=read(fd, p, SLEN);
  close(fd);
  if (bytes<=0) goto errexit;
  p[bytes]='\0';
  write1(p,strlen(p));
  _exit(0);

  errexit:
  write1("9\n",2);
  _exit(1);
*/
}

int main(int argc, char *argv[]) {
  register ssize_t bytes;
  register int fd;
  char p[SLEN+1];

  if (argc < 2) { write2(msg, strlen(msg)); _exit(2); }
  
  fd = 0;
  strncpy(filename, argv[1], SLEN);
  filename[SLEN] = 0;
/*
  signal(SIGCHLD, sigchld_handler);
*/
  signal(SIGALRM, sigchld_handler);
  alarm(470);
  if (setjmp(check_procstate)) goto error;

  fd=open(argv[1], O_RDONLY|O_NONBLOCK);
  if (fd == -1) goto error;
  bytes=read(fd, p, SLEN);
  close(fd);
  if (bytes<=0) goto error;
  p[bytes]='\0';
  write1(p,bytes);
  _exit(0);

  error:
  write1("9\n",2);
  _exit(1);
}
