/*
 * $Id: nagios-check-process.c 691 2017-06-04 23:12:04Z fwbergm $
 * nagios-check-process.c
 * counts processes with processname given at command line
 * Frank Bergmann, 11/2008
 */

static const char msg[]="missing argument (processname) like: cron\n";

#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>
#include "../lib/libfwb.h"

#define PATHNAME_SIZE 1024

int main(int argc,char *const argv[]) {
  register uint32_t count;
  register DIR *dptr;
  register struct dirent *eptr;
  register char *p;
  register int pstat;
  char pathname[2*PATHNAME_SIZE];
  char statbuf[PATHNAME_SIZE+1];
  char procname[PATHNAME_SIZE+6];

  if (argc < 2) { write2(msg, strlen(msg)); _exit(2); }
  p = procname;
  *p = '\0';
  strcat(p, " (");
  strcat(p,argv[1]);
  strcat(p, ") ");
  p = pathname;
  dptr = opendir("/proc");
  if (dptr == NULL) _exit(1);
  for (count=0; (eptr=readdir(dptr))!=NULL;) {
    if ((*eptr->d_name < '0') || (*eptr->d_name > '9')) continue;
    *p = '\0'; strcat(p, "/proc/");
    strcat(p, eptr->d_name);
    strcat(p, "/stat");
    pstat = open(p, O_RDONLY);
    if (pstat > 0) {
      if (read(pstat, statbuf, PATHNAME_SIZE) > 2) {
        statbuf[PATHNAME_SIZE] = '\0';
        if (str_index(statbuf, procname) >= 0) count++;
      }
      close(pstat);
    }
  };
  closedir(dptr);
  /* nagios "adjustments": */
  if (count < 1) count = 9999;
  putlong(count);
  _exit(0);
}
