%debug_package %{nil}
%define _unpackaged_files_terminate_build 0
#define __os_install_post %{nil}

%global _hardened_build 1
%bcond_with monitoringfs

%if 0%{?_with_diet:1}
%define diet 1
%else
%define diet 0
%endif

Summary: admin and monitoring tools
Name: ngtx
Version: 20221016
Release: 1%{?_with_diet:diet}%{?dist}
Source0: http://downloads.tuxad.de/ngtx/%{name}-%{version}.tgz
#Source1: http://downloads.tuxad.de/ngtx/%{name}-%{version}.tgz.asc
License: GPL v2
Group: Admin
URL: http://www.tuxad.de/ngtx.html
BuildRoot: %{_tmppath}/buildroot-%{name}-%{version}
BuildRequires: nasm
%if %{with monitoringfs}
BuildRequires: fuse-devel
%endif
%if %diet
BuildRequires: dietlibc
%endif

%description 	
small tools for admin's daily work and monitoring:
The tools are primarily written to make sysadmin's daily work more
easy. Most of them are written to be used in bash scripts.

ngtx also contains some nagios check tools/plugins and knoerre, the http
nagios remote check server, the fastest remote monitoring software.

The tools are:
actionwhenfileold, breakout, cacti_remote_by_http, check_diskusagelocal,
check_http_fwb, check_mounts, check_remote_by_http, check_remote_by_http_time,
check_remote_by_udp, check_remote_by_udp_multi, check_remote_by_udp_time,
check_true, chrootuser, daemonize, daemonizep, direntries, dirscan, griller,
ipv4conv, killwebprocs, knoerre, knoerre-conf, knoerre-update-tcprules,
knoerred, knoerrehd, lkill, lns, lps, msleep100, msleep250, msleep500,
msleep750, nagios-check-backup, nagios-check-diskfree,
nagios-check-longuserprocesses, nagios-check-nfs, nagios-check-process,
nagios-show-addresses, nts2hrf, postfix-mailqsize, postfix-saslusernames,
process_perfdata, sfgrep, showip, svscanboot2, svscanboot3, testcgi

rpmbuild options:
--with diet (build with dietlibc, diet must be in PATH)
--with monitoringfs

%if %{with monitoringfs}
%package monitoringfs
Summary: monitoring values as filesystem
Group: Admin
Requires: %{name} = %{version}-%{release}
Requires: fuse

%description monitoringfs
This package contains monitoringfs for %{name}.
It shows local or remote monitoring values as files in a filesystem.
%endif


%prep
%setup -q
make distclean


%build
%if %diet
make OPTFLAGS="%{optflags}"
%else
make DIET="" OPTFLAGS="%{optflags}"
%endif
%if %{with monitoringfs}
make OPTFLAGS="%{optflags}" monitoringfs
%endif


%install
[ -d  ${RPM_BUILD_ROOT} -a "${RPM_BUILD_ROOT}" != "/" ] && rm -rf  ${RPM_BUILD_ROOT}
%if %diet
%makeinstall DESTDIR=${RPM_BUILD_ROOT} OPTFLAGS="%{optflags}"
%else
%makeinstall DESTDIR=${RPM_BUILD_ROOT} DIET="" OPTFLAGS="%{optflags}"
%endif
%if %{with monitoringfs}
make DESTDIR=${RPM_BUILD_ROOT} OPTFLAGS="%{optflags}" monitoringfs-install
%endif
# dirty fix to avoid conflict with Red Hat's usleep
[ -e /bin/usleep ] && rm -f ${RPM_BUILD_ROOT}%_mandir/man1/usleep.1* ${RPM_BUILD_ROOT}%_bindir/usleep

# install startscript(s) and config
install -m 755 -d ${RPM_BUILD_ROOT}/%{_sysconfdir}/{xinetd.d,sysconfig,rc.d/init.d}
cp -af knoerre/knoerre.xinetd ${RPM_BUILD_ROOT}/%{_sysconfdir}/xinetd.d/knoerre
cp -af startscripts/%{_sysconfdir}/sysconfig/knoerred ${RPM_BUILD_ROOT}/%{_sysconfdir}/sysconfig/knoerred
cp -af startscripts/%{_sysconfdir}/rc.d/init.d/knoerred ${RPM_BUILD_ROOT}/%{_sysconfdir}/rc.d/init.d/knoerred
chmod 755 ${RPM_BUILD_ROOT}/%{_sysconfdir}/rc.d/init.d/knoerred
install -m 755 -d ${RPM_BUILD_ROOT}/opt/ngtx/knoerre/supervise
cat >${RPM_BUILD_ROOT}/opt/ngtx/knoerre/run <<EOF
#!/bin/sh
exec 2>&1
sleep 1
exec /usr/local/bin/tcpserver -c 80 -v -RHl localhost -x /etc/knoerre.tcprules.cdb -X 0 8889 /usr/bin/knoerre
EOF
chmod 755 ${RPM_BUILD_ROOT}/opt/ngtx/knoerre/run
%if %{with monitoringfs}
test -e ${RPM_BUILD_ROOT}/usr/bin/monitoringfs
test -e ${RPM_BUILD_ROOT}/usr/bin/monitoringfshttp
%else
rm -f ${RPM_BUILD_ROOT}/usr/bin/monitoringfs ${RPM_BUILD_ROOT}/usr/bin/monitoringfshttp ${RPM_BUILD_ROOT}/usr/share/man/man1/monitoringfs.1*
%endif


%post
echo
umask 022
mkdir -p /command /service
rm -f /command/svscanboot3
ln -s %_bindir/svscanboot3 /command/svscanboot3
# knoerred
/sbin/chkconfig --add knoerred 2>/dev/null;/bin/true
service knoerred restart &>/dev/null;true
# knoerre/xinetd
service xinetd restart &>/dev/null;true
# knoerre/tcpserver
grep -q ^knoerre: /etc/hosts.deny || echo knoerre: ALL >>/etc/hosts.deny
grep -q ^knoerre: /etc/hosts.allow || echo knoerre: 10.255.255.255 >>/etc/hosts.allow
knoerre-update-tcprules
if [ -e /etc/init/daemontools.conf ]
then
  sed -i 's,^exec .*,exec /command/svscanboot3,' /etc/init/daemontools.conf
fi
if grep -q '^SV:.*svscanboot$' /etc/inittab
then
  sed -i s,^SV:.*,SV:2345:respawn:/command/svscanboot3, /etc/inittab
  echo /etc/inittab modified
fi
echo
echo "You may wish to edit /etc/sysconfig/knoerred"
echo "You may wish to edit hosts.(deny|allow). Don't forget to execute knoerre-update-tcprules!"
ln -s /opt/ngtx/knoerre /service/knoerre 2>/dev/null;true
/sbin/telinit q
/sbin/initctl start daemontools 2>/dev/null;true
echo "You may wish to install ucspi-tcp and daemontools."


%postun
/sbin/chkconfig --del knoerred 2>/dev/null;/bin/true
service xinetd restart &>/dev/null;true
service knoerred stop &>/dev/null;true
cd /service/knoerre 2>/dev/null && { /bin/rm -f /service/knoerre; /command/svc -dx .; }
if [ -e /etc/init/daemontools.conf ]
then
  sed -i 's,^exec .*,exec /command/svscanboot,' /etc/init/daemontools.conf
fi
if grep -q '^SV:.*svscanboot3$' /etc/inittab
then
  sed -i s,^SV:.*,SV:2345:respawn:/command/svscanboot, /etc/inittab
  echo /etc/inittab modified
fi
rm -f /command/svscanboot3
/sbin/telinit q
# be paranoid on broken packages or installs:
cd /opt/ngtx/knoerre 2>/dev/null && test -x run && ln -s /opt/ngtx/knoerre /service/knoerre 2>/dev/null;true
test -e %_sysconfdir/sysconfig/knoerred && service knoerred restart &>/dev/null;true


%clean
[ -d  ${RPM_BUILD_ROOT} -a "${RPM_BUILD_ROOT}" != "/" ] && rm -rf  ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root,-)
%doc README README.sac-tools COPYING CHANGELOG CHANGELOG.nagios-fwb CHANGELOG.sac-tools ngtx.spec .config knoerre/knoerre.xinetd
%doc doc/ngtx-overview.dot doc/ngtx-overview.png doc/ngtx-quickstart-de.pdf doc/ngtx-quickstart-de.txt
%_sysconfdir/rc.d/init.d/knoerred
%config(noreplace) %_sysconfdir/sysconfig/knoerred
%config(noreplace) %_sysconfdir/xinetd.d/knoerre
/opt/ngtx/knoerre/run
%_bindir/actionwhenfileold
%_bindir/breakout
%_bindir/build-chroot.sh
%_bindir/cacti_remote_by_http
%_bindir/camelCase
%_bindir/check-nfs
%_bindir/check_diskusagelocal
%_bindir/check_http_fwb
%_bindir/check_mounts
%_bindir/check_remote_by_http
%_bindir/check_remote_by_http_time
%_bindir/check_remote_by_udp
%_bindir/check_remote_by_udp_multi
%_bindir/check_remote_by_udp_time
%_bindir/check_tcp_connect
%_bindir/check_true
%_bindir/chownu
%_bindir/chrootuser
%_bindir/daemonize
%_bindir/daemonizep
%_bindir/direntries
%_bindir/dirscan
%_bindir/ftsm
%_bindir/griller
%_bindir/ipv4conv
%_bindir/killwebprocs
%_bindir/knoerre
%_bindir/knoerre-conf
%_bindir/knoerre-update-tcprules
%_bindir/knoerred
%_bindir/knoerrehd
%_bindir/lkill
%_bindir/lns
%_bindir/lps
%_bindir/mboxscrub
%_bindir/msleep100
%_bindir/msleep250
%_bindir/msleep500
%_bindir/msleep750
%_bindir/nagios-check-backup
%_bindir/nagios-check-diskfree
%_bindir/nagios-check-longuserprocesses
%_bindir/nagios-check-nfs
%_bindir/nagios-check-process
%_bindir/nagios-show-addresses
%_bindir/nts2hrf
%_bindir/postfix-mailqsize
%_bindir/postfix-saslusernames
%_bindir/procage
%_bindir/process_perfdata
%_bindir/sfgrep
%_bindir/show-cipher-preference
%_bindir/showip
%_bindir/sstrip
%_bindir/svscanboot2
%_bindir/svscanboot3
%_bindir/testcgi
%_bindir/user-wrapper
%_mandir/man1/actionwhenfileold.1.*
%_mandir/man1/cacti_remote_by_http.1.*
%_mandir/man1/camelCase.1.*
%_mandir/man1/check-nfs.1.*
%_mandir/man1/check_diskusagelocal.1.*
%_mandir/man1/check_http_fwb.1.*
%_mandir/man1/check_mounts.1.*
%_mandir/man1/check_remote_by_http.1.*
%_mandir/man1/check_remote_by_http_time.1.*
%_mandir/man1/check_remote_by_udp.1.*
%_mandir/man1/check_remote_by_udp_multi.1.*
%_mandir/man1/check_remote_by_udp_time.1.*
%_mandir/man1/check_tcp_connect.1.*
%_mandir/man1/chownu.1.*
%_mandir/man1/check_true.1.*
%_mandir/man1/daemonize.1.*
%_mandir/man1/direntries.1.*
%_mandir/man1/dirscan.1.*
%_mandir/man1/ftsm.1.*
%_mandir/man1/griller.1.*
%_mandir/man1/ipv4conv.1.*
%_mandir/man1/killwebprocs.1.*
%_mandir/man1/knoerre-conf.1.*
%_mandir/man1/knoerre-update-tcprules.1.*
%_mandir/man1/knoerre.1.*
%_mandir/man1/knoerred.1.*
%_mandir/man1/knoerrehd.1.*
%_mandir/man1/lkill.1.*
%_mandir/man1/lns.1.*
%_mandir/man1/lps.1.*
%_mandir/man1/mboxscrub.1.*
%_mandir/man1/nagios-check-backup.1.*
%_mandir/man1/nagios-check-diskfree.1.*
%_mandir/man1/nagios-check-longuserprocesses.1.*
%_mandir/man1/nagios-check-nfs.1.*
%_mandir/man1/nagios-check-process.1.*
%_mandir/man1/nagios-show-addresses.1.*
%_mandir/man1/nts2hrf.1.*
%_mandir/man1/postfix-mailqsize.1.*
%_mandir/man1/postfix-saslusernames.1.*
%_mandir/man1/procage.1.*
%_mandir/man1/process_perfdata.1.*
%_mandir/man1/sfgrep.1.*
%_mandir/man1/show-cipher-preference.1.*
%_mandir/man1/showip.1.*
%_mandir/man1/testcgi.1.*
%_mandir/man1/user-wrapper.1.*
%_mandir/man8/chrootuser.8.*

%if %{with monitoringfs}
%files monitoringfs
%defattr(-, root, root,-)
%_bindir/monitoringfs
%_bindir/monitoringfshttp
%_mandir/man1/monitoringfs.1.*
%endif


%changelog
* Sun Jul 16 2016 Frank Bergmann <http://www.tuxad.com/> 20170716-1
- added camelCase

* Sun Oct 30 2016 Frank Bergmann <http://www.tuxad.com/> 20161030-1
- added mboxscrub

* Mon Sep 19 2016 Frank Bergmann <http://www.tuxad.com/> 20160919-1
- griller: added USERIGNORE, USERQUADTIME and RSS_SOFTLIMIT
- added procage (not installed)
- update to r686

* Sat Aug 27 2016 Frank Bergmann <http://www.tuxad.com/> 20160827-1
- added show-cipher-preference

* Sat Jun 25 2016 Frank Bergmann <http://www.tuxad.com/> 20160625-1
- updated to 20160625 (r680)

* Mon Aug 11 2014 Frank Bergmann <http://www.tuxad.com/> 20140811-1
- added check_tcp_connect and ftsm
- update til r670

* Fri Aug 23 2013 Frank Bergmann <http://www.tuxad.com/> 20130823-1
- update til r663

* Wed Jul 24 2013 Frank Bergmann <http://www.tuxad.com/> 20130724-1
- update til r659

* Thu May 30 2013 Frank Bergmann <http://www.tuxad.com/> 20130530-1
- update til r645

* Sun Mar 24 2013 Frank Bergmann <http://www.tuxad.com/> 20130324-1
- update til r638

* Sat Feb 23 2013 Frank Bergmann <http://www.tuxad.com/> 20130223-1
- update to r631
- fix spec file

* Sat Dec 15 2012 Frank Bergmann <http://www.tuxad.com/> 20121215-1
- diskusagelocal small fs bugfix

* Fri Oct 05 2012 Frank Bergmann <http://www.tuxad.com/> 20121005-1
- fix reading /proc/mounts on key mounts, it may be more data than PAGE_SIZE
- fix knoerre.1 tcp milliseconds => microseconds

* Sun Sep 16 2012 Frank Bergmann <http://www.tuxad.com/> 20120916-1
- monitoringfs as conditional build

* Tue Aug 21 2012 Frank Bergmann <http://www.tuxad.com/> 20120820-1
- added doc ngtx-quickstart-de

* Mon Jul 30 2012 Frank Bergmann <http://www.tuxad.com/> 20120708-5
- fix do_check_cmdline() decrease
- fix processd bug, introduced with kconfig

* Wed Jul 25 2012 Frank Bergmann <http://www.tuxad.com/> 20120708-3
- added tcpserver support for knoerre
- xinetd knoerre conf disabled as default
- post and postun extended for automatic configuration and (re)start of services

* Mon Jul 23 2012 Frank Bergmann <http://www.tuxad.com/> 20120708-2
- added drive cmd error
- added chkconfig--add at post-install

* Sun Jul  8 2012 Frank Bergmann <http://www.tuxad.com/> 20120708-1
- monitoringfs moved into separate package

* Wed Jun 27 2012 Frank Bergmann <http://www.tuxad.com/> 20120415-6
- x-bit on init-script
- symlink /command/svscanboot3 at post-install

* Thu Mar 15 2012 Frank Bergmann <http://www.tuxad.com/> 20120313-4
- added x86_64 patch
- added BuildRequires
- added option "--with diet"
- added startscripts and config for knoerred and knoerre

* Thu Feb 16 2012 Frank Bergmann <http://www.tuxad.com/> 20120216
- new version with kconfig

* Sun Oct 30 2011 Frank Bergmann <http://www.tuxad.com/> 20111030
- sac-tools and nagios-fwb packages are now re-merged to "ngtx"
- some more docs and man-pages

* Fri Dec  4 2009 Frank Bergmann <http://www.tuxad.com/> 20091204
- uh! spec-file needed heavy maintenance...

* Sun Dec 30 2007 Frank Bergmann <http://www.tuxad.com/> 20071230
- rename nagios-check-backup-rsync to nagios-check-backup, small bugfix
- small Makefile changes
