#!/usr/bin/env python

"""
check_diskusagelocal.py
a python implementation of nagios plugin check_diskusagelocal

FWB 2012-06-29
"""

import os
import sys
import getopt

def usage():
  print """
check_diskusagelocal.py
usage: check_diskusagelocal.py -w warnlevel -c critlevel
"""
  sys.exit(2)

try:
  opts, args = getopt.getopt(sys.argv[1:], "w:c:h")
except getopt.GetoptError:
  usage()
warn = 80
crit = 90
for o, a in opts:
  if o == "-c":
    crit = int(a)
  if o == "-w":
    warn = int(a)

max_percent = 0
df = os.popen('/bin/df -l -k')
df.readline()
for l in df.readlines():
  ls = l.split()
  if len(ls) == 1:
    olddev = ls[0]
  else:
    if len(ls) < 6:
      ls.insert(0,olddev)
    percent = int(ls[4].rstrip('%'))
    if percent > max_percent:
      max_l = ls
      max_percent = percent
df.close()
if max_percent > crit:
  print 'DISK CRITICAL - %d%% (%s %d/%d/%d GB)| disk=%d;%d;%d' % \
    (max_percent, max_l[5], int(max_l[1])/1024/1024, int(max_l[2])/1024/1024, int(max_l[3])/1024/1024, max_percent, warn, crit)
  sys.exit(2)
if max_percent > warn:
  print 'DISK WARNING - %d%% (%s %d/%d/%d GB)| disk=%d;%d;%d' % \
    (max_percent, max_l[5], int(max_l[1])/1024/1024, int(max_l[2])/1024/1024, int(max_l[3])/1024/1024, max_percent, warn, crit)
  sys.exit(1)
print "DISK OK - %d%%| disk=%d;%d;%d" % \
    (max_percent, max_percent, warn, crit)
sys.exit(0)

