#!/bin/bash

DESTDIR=/
PYRRE_DIR="$DESTDIR"/usr/local/pyrre
SYSCONF_DIR="$DESTDIR"/etc

mkdir -p $PYRRE_DIR/supervise  $PYRRE_DIR/log/supervise
chmod 700 $PYRRE_DIR/supervise  $PYRRE_DIR/log/supervise

cat >$PYRRE_DIR/run <<EOF
#!/bin/sh
exec 2>&1
exec /usr/local/sbin/pyrre.py
EOF
chmod 744 $PYRRE_DIR/run

cat >$PYRRE_DIR/log/run <<EOF
#!/bin/sh
exec multilog t ./main e 2>&1 |tai64nlocal |readproctitle pyrre: .................................................................
EOF
chmod 744 $PYRRE_DIR/log/run

cat >$SYSCONF_DIR/pyrrerc <<EOF
# resource config for pyrre webserver
# note: cmd-strings for internal commands can be left empty
HandlerClass.cmds = {
    '/loadavg' : 'cat /proc/loadavg',
    '/load1' : '',
    '/monit': '/usr/sbin/nagios-check-monit',
    '/dfoldhome': '/usr/sbin/nagios-check-diskfree /home',
    '/rsbackup': '/usr/sbin/nagios-check-backup',
    '/mailqs1': '/usr/sbin/postfix-mailqsize',
    '/varmysql': '/usr/sbin/nagios-check-diskfree /var/lib/mysql/mysql.sock',
    '/saegef': '/usr/sbin/nagios-check-process saegefisch',
    '/longproc': '/usr/sbin/nagios-check-longuserprocesses 630 vsftpd bash sftp-server',
}
EOF
chmod 644 $SYSCONF_DIR/pyrrerc

