/*
 * camelCase.c
 * converts arg1 or stdin to camelCase
 * $Id: camelCase.c 695 2017-07-16 18:59:24Z fwbergm $
 */

#include <unistd.h>
#ifdef _USE_LIBFWB_
#include "lib/libfwb.h"
#endif
#define BUFFER_LEN 1024

int main(int argc,char **argv) {
  register char *input;
  register char *output;
  register char *output_end;
  register char c = 0;
  char in_buf[BUFFER_LEN+1];
  char out_buf[BUFFER_LEN+1];
  int read_bytes = 0;
  int read_from_stdin = 0;
  int to_lower = 1;
  int first_char = 1;

  if (argc>1) {
    input = argv[1];
  } else {
    read_from_stdin = 1;
    input = in_buf;
    read_bytes = read(0, input, BUFFER_LEN);
    if (read_bytes <= 0) _exit(0);
    input[read_bytes] = 0;
  }

  output = out_buf;
  output_end = out_buf + BUFFER_LEN;
  for (;;++input) {
    if (!*input) break;
    if (output >= output_end) break;
    if (first_char) {
      if (*input < 'A') continue;
      if (*input > 'z') continue;
      if ((*input > 'Z') && (*input < 'a')) continue;
      first_char = 0;
    }
    if (((*input >= 'A') && (*input <= 'Z')) ||
        ((*input >= 'a') && (*input <= 'z'))) {
      if (*input > 'Z') {
        if (to_lower) {
          c = *input;
        } else {
          c = *input - 32;
        }
      } else {
        if (to_lower) {
          c = *input + 32;
        } else {
          c = *input;
        }
      }
      *output++ = c;
      to_lower = 1;
      continue;
    }
    if ((*input >= '0') && (*input <= '9')) {
      *output++ = *input;
      to_lower = 0;
    }
    if (c > 'Z') to_lower = 0;
    // /*if (c > 'Z')*/ to_lower = 0;
  }
  *output++ = '\n';
#ifdef _USE_LIBFWB_
  write1(out_buf, output - out_buf);
#else
  write(1, out_buf, output - out_buf);
#endif
  _exit(0);
}
