;
; daemonize.asm
; run a program (commonly a shell script) as daemon
; this asm-Version must be processed by "nasm -f bin" to produce a executable
; Frank Bergmann www.tuxad.com, 11/2007
; 

            %include "lib/elfheader.asm"

_start:

        xor     eax, eax
        inc     eax
        inc     eax
        int     0x80      ;fork()
        or      eax,eax
        jz      child
        inc     eax
        jz      error
        xor     ebx, ebx  ;father: return 0
        xor     eax, eax
        inc     eax
        int     0x80      ;_exit()
error   xor     ebx, ebx
        inc     ebx       ;error on fork: return 1
        xor     eax, eax
        inc     eax
        int     0x80      ;_exit()

child   xor     eax, eax
        mov     al,66
        int     0x80      ;setsid()

        ;xor     ebx, ebx
        mov     ebx,23
        xor     eax, eax
        mov     al,60
        int     0x80      ;umask()

        mov     ebx,rdirstr
        xor     eax, eax
        mov     al,12
        int     0x80      ;chdir()

        xor     ebx, ebx
        xor     eax,eax
        mov     al,6
        int     0x80      ;close(0)

        xor     ebx, ebx
        inc     ebx
        xor     eax,eax
        mov     al,6
        int     0x80      ;close(1)

        xor     ebx, ebx
        inc     ebx
        inc     ebx
        xor     eax,eax
        mov     al,6
        int     0x80      ;close(2)

        lea     ecx,[esp+8]
        mov     ebx,[ecx]
        xor     edx, edx
        xor     eax,eax
        mov     al,11
        int     0x80

        xor     ebx, ebx
        inc     ebx
        inc     ebx       ;error on exec: return 2 to init
        xor     eax, eax
        inc     eax       ;_exit()
        int     0x80

rdirstr     db      "/",0

filesize      equ     $ - $$
