/*
 * daemonizep
 * run a program (commonly a shell script) as daemon and print its PID
 * Frank Bergmann www.tuxad.com, 6/2011
 */

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <features.h>

#include <stdint.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/resource.h>
#include <sys/time.h>
#include <unistd.h>

#include <sys/syscall.h>
#define write1(b,c) (syscall(__NR_write, 1, b, c))
#define chdirv(p) (syscall(__NR_chdir, p))

static void putuint32(uint32_t i) {
  register char *pbuf;
  register int c;
  char buf[10];
  uint32_t d;
  int o;

  o = 0; pbuf = buf;
  for (d = 1000000000; d > 1; d /= 10) {
    c = i / d;
    if ((c > 0) || (o)) {
      *pbuf = c + '0';
      ++pbuf;
      i = i - (c * d);
      o = 1;
    }
  }
  *pbuf = i + '0'; ++pbuf;
  *pbuf = '\n'; ++pbuf;
  write1(buf, pbuf - buf);
}

int main(int argc,char *const argv[]) {
  pid_t pid;
  if ((pid=fork())<0) {
    _exit(1);
  } else if (pid!=0) {
    putuint32(pid);
    _exit(0);
  }
  setsid();
  umask(027);
  chdirv("/");
  close(0); close(1); close(2);
  execve(argv[1],argv+1,0);
  _exit(2); /* dummy: init doesn't care; */
}
