/**
 * griller.h
 * $Id: griller.h 691 2017-06-04 23:12:04Z fwbergm $
 */

#include "../lib/libfwb.h"
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>
#include <pwd.h>
#include <stdlib.h>
#include <stdint.h>
#include <sysexits.h>
#include <signal.h>

/* some adjustable limits which must fit your needs */
#define MAX_CMDLINE_EXCLUDES 100
#define MAX_USERIGNORES 100
#define MAX_USERQUADTIME 100
/* max no of users in your /etc/passwd */
#define MAX_USERS 50000


#define BUFSIZE 16384
#define WRITEBUFSIZE 2048
#define STRING_SIZE 255

extern uint32_t kill_level;
extern uint32_t min_uid;
extern uint32_t max_uid;
extern int killing_off;
extern uint32_t maxloadsoft;
extern uint32_t maxloadhard;
extern uint32_t procsoftlimit;
extern uint32_t prochardlimit;
extern const char *cmdline_excludes[];
extern const char *userignores[];
extern const char *userquadtimes[];
extern uint32_t rss_softlimit;

void get_envvars();
uint64_t get_start_time();
uint64_t get_uptime_in_seconds();
int get_jiffies_per_second(uint64_t uptime);
int str_index3(const char* a, register const char* b, int al, register int t);
char *field(register const char *s, uint16_t index);
uint32_t get_load1();
int is_socket_link(register const char *s);
