#include "griller.h"

uint64_t get_start_time() {
  register char *p;
  uint64_t val64;
  ssize_t c;
  int rf;
  char filebuf[BUFSIZE+1];

  rf = open("/proc/self/stat", O_RDONLY);
  if (rf == -1) _exit(EX_OSFILE);
  p = filebuf;
  c = read(rf, p, BUFSIZE);
  close(rf);
  if (c == -1) _exit(EX_OSFILE);
  p[c] = '\0';
  /* starttime */
  str2uint64(field(p, 21), &val64); /* no error checks */
  return val64;
}

uint64_t get_uptime_in_seconds() {
  register char *p;
  uint64_t val64;
  ssize_t c;
  int rf;
  char filebuf[BUFSIZE+1];

  rf = open("/proc/uptime", O_RDONLY);
  if (rf == -1) _exit(EX_OSFILE);
  p = filebuf;
  c = read(rf, p, BUFSIZE);
  close(rf);
  if (c == -1) _exit(EX_OSFILE);
  p[c] = '\0';
  str2uint64(p, &val64); /* no error checks */
  return val64;
}

int get_jiffies_per_second(uint64_t uptime) {
  int jiffies_per_second;

  jiffies_per_second = ((int)(get_start_time() / uptime)) + 1;
  /**
   * 10 S/390 (sometimes)
   * 20 User-mode Linux
   * 32 ia64 emulator
   * 64 StrongARM /Shark
   * 100 normal Linux
   * 128 MIPS, ARM
   * 1000 ARM
   * 1024 Alpha, ia64
   * 1200 Alpha
   */
  /* Rundung auf 2 Hertz */
  jiffies_per_second = ((int)(jiffies_per_second / 2)) * 2;
  return jiffies_per_second;
}
