#include "griller.h"

void get_envvars() {
  register char *p;
  uint32_t val32;

  p = getenv("KILL_LEVEL");
  if (!p || !str2uint32(p, &val32)) {
    kill_level = 3600; /* seconds */
  } else {
    kill_level = val32;
  }
  p = getenv("MINUID");
  if (p && str2uint32(p, &val32)) {
    min_uid = val32;
  }
  p = getenv("MAXUID");
  if (p && str2uint32(p, &val32)) {
    max_uid = val32;
  }
  p = getenv("KILLING_OFF");
  if (!p) {
    killing_off = 0;
  } else {
    killing_off = 1;
  }
  p = getenv("MAXLOADSOFT");
  if (!p || !str2uint32(p, &val32)) {
    maxloadsoft = 40;
  } else {
    maxloadsoft = val32;
  }
  p = getenv("MAXLOADHARD");
  if (!p || !str2uint32(p, &val32)) {
    maxloadhard = 60;
  } else {
    maxloadhard = val32;
  }
  p = getenv("PROCSOFTLIMIT");
  if (!p || !str2uint32(p, &val32)) {
    procsoftlimit = 15;
  } else {
    procsoftlimit = val32;
  }
  p = getenv("PROCHARDLIMIT");
  if (!p || !str2uint32(p, &val32)) {
    prochardlimit = 45;
  } else {
    prochardlimit = val32;
  }
  p = getenv("RSS_SOFTLIMIT");
  if (!p || !str2uint32(p, &val32)) {
    rss_softlimit = 0;
  } else {
    rss_softlimit = val32;
  }

  val32 = 0;
  p = getenv("CMDLINE_EXCLUDES");
  if (p) {
    /* set up array with command line substrings to be excluded from killing */
    for (;;) {
      if (val32 == MAX_CMDLINE_EXCLUDES) break;
      while (*p == ';') ++p;
      if (*p == 0) p = 0;
      cmdline_excludes[val32] = p;
      if (!p) break;
      for (;;) {
        ++p; if (*p == 0) break; if (*p == ';') { *p = 0; ++p; break; }
        ++p; if (*p == 0) break; if (*p == ';') { *p = 0; ++p; break; }
        ++p; if (*p == 0) break; if (*p == ';') { *p = 0; ++p; break; }
        ++p; if (*p == 0) break; if (*p == ';') { *p = 0; ++p; break; }
      }
      ++val32;
    }
  } else {
    /* clear exclude array */
    for (;;) {
      cmdline_excludes[val32] = 0;
      ++val32;
      if (val32 == MAX_CMDLINE_EXCLUDES) break;
    }
  }

  val32 = 0;
  p = getenv("USERIGNORE");
  if (p) {
    /* set up array with user accounts of processes to be excluded from killing */
    for (;;) {
      if (val32 == MAX_USERIGNORES) break;
      while (*p == '|') ++p;
      if (*p == 0) p = 0;
      userignores[val32] = p;
      if (!p) break;
      for (;;) {
        ++p; if (*p == 0) break; if (*p == '|') { *p = 0; ++p; break; }
        ++p; if (*p == 0) break; if (*p == '|') { *p = 0; ++p; break; }
        ++p; if (*p == 0) break; if (*p == '|') { *p = 0; ++p; break; }
        ++p; if (*p == 0) break; if (*p == '|') { *p = 0; ++p; break; }
      }
      ++val32;
    }
  } else {
    /* clear userignore array */
    for (;;) {
      userignores[val32] = 0;
      ++val32;
      if (val32 == MAX_USERIGNORES) break;
    }
  }

  val32 = 0;
  p = getenv("USERQUADTIME");
  if (p) {
    /* set up array with user accounts of processes to be excluded from killing */
    for (;;) {
      if (val32 == MAX_USERQUADTIME) break;
      while (*p == '|') ++p;
      if (*p == 0) p = 0;
      userquadtimes[val32] = p;
      if (!p) break;
      for (;;) {
        ++p; if (*p == 0) break; if (*p == '|') { *p = 0; ++p; break; }
        ++p; if (*p == 0) break; if (*p == '|') { *p = 0; ++p; break; }
        ++p; if (*p == 0) break; if (*p == '|') { *p = 0; ++p; break; }
        ++p; if (*p == 0) break; if (*p == '|') { *p = 0; ++p; break; }
      }
      ++val32;
    }
  } else {
    /* clear userquadtimes array */
    for (;;) {
      userquadtimes[val32] = 0;
      ++val32;
      if (val32 == MAX_USERQUADTIME) break;
    }
  }

  return;
}
