/*
#define _FILE_OFFSET_BITS 64
*/
#ifndef _GNU_SOURCE
#define _GNU_SOURCE 1
#endif
#include <features.h>
#include "lib/libfwb.h"
#include <limits.h>
#include <stdint.h>
#include <sys/syscall.h>
#include <errno.h>
#include <syslog.h>
#include <alloca.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <string.h>
/*
#include <stdio.h>
#include <pwd.h>
#include <grp.h>
#include <fcntl.h>
*/
/*
#include <signal.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <syslog.h>
#include <sched.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <pwd.h>
#include <grp.h>
*/

/*
// Functions in filesystem.c
int file_exists(char *filename);
int file_is_symbollink(char *filename);
uid_t file_get_uid(char *filename);
gid_t file_get_gid(char *filename);
uid_t file_get_uid_l(char *filename);
gid_t file_get_gid_l(char *filename);

int check_path(char *script_path);
int check_permissions(char *script_path);

// Errorcode, only used internally
#define ERRCODE_WRONG_ENVIRONMENT 1
#define ERRCODE_WRONG_PATH 2
#define ERRCODE_LOW_UID 3
#define ERRCODE_LOW_GID 6
#define ERRCODE_FILE_NOT_FOUND 4
#define ERRCODE_WRONG_PARENT 5
#define ERRCODE_WRONG_PERMISSIONS 7
#define ERRCODE_SYMBOLLINK_NO_MATCH 9
#define ERRCODE_NO_LOG 8
#define ERRCODE_UNKNOWN 9999
#define ERRCODE_MEMORY 10
#define ERRCODE_WRONG_UID 11
#define ERRCODE_WRONG_GID 12

void error_exit(int errcode);
void error_msg_exit(int errcode, char *msg, char *file, int line);
void error_sysmsg_exit(int errcode, char *msg, char *file, int line);

extern int log_initialized;

void suphp_init_log();
void suphp_log_error(char* err_msg, ...);
void suphp_log_info(char* info_msg, ...);
void suphp_log(char* msg, char* category);

int suphp_setenv(const char *name, const char *value, int overwrite);
int suphp_unsetenv(const char *name);

#ifndef OPT_DISABLE_CHECKPATH
#define OPT_CHECKPATH
#endif

#ifndef OPT_MIN_UID
#define OPT_MIN_UID 100
#endif

#ifndef OPT_MIN_GID
#define OPT_MIN_GID 100
#endif

#ifndef OPT_APACHE_USER
#define OPT_APACHE_USER "wwwrun"
#endif

#ifndef OPT_PATH_TO_PHP
#define OPT_PATH_TO_PHP "/usr/bin/php"
#endif

#ifndef OPT_LOGFILE
#define OPT_LOGFILE "/var/log/httpd/suphp_log"
#endif

*/


#define APACHE_UID 81
#define APACHE_GID 81
#define MINUID 1000
#define MINGID 1000
#define PATHTOPHP "/usr/bin/php5-cgi"
/*
#define PATHTOSUPHP "/usr/sbin/suphp"
*/
#define PATHTOSUPHP "/usr/bin/php"
#define PATHENV "/bin:/usr/bin:/usr/local/bin:/usr/sbin:/usr/local/typo3sh/bin"

static const char const *allowed_suffixes[] = {
  ".php",
  ".php4",
  ".php5",
  ".html",
  ".html",
 0
};

static const char *cgivars[] = {
  "GATEWAY_INTERFACE",
  "SERVER_PROTOCOL",
  "SERVER_SOFTWARE",
  "SERVER_NAME",
  "SERVER_PORT",
  "REQUEST_METHOD",
  "REQUEST_URI",
  "SCRIPT_NAME",
  "REMOTE_ADDR",
  "REMOTE_PORT",
  "REMOTE_IDENT",
  "HTTP_USER_AGENT",
  "HTTP_COOKIE",
  "HTTP_REFERER",
  "HTTP_ACCEPT_ENCODING",
  "AUTH_TYPE",
  "CONTENT_TYPE",
  "CONTENT_LENGTH",
  "QUERY_STRING",
  "PATH_INFO",
  "PATH_TRANSLATED",
  "SCRIPT_FILENAME",
  "HTTP_HOST", /* actually not a CGI var */
  0
};
/**
 * also actually no CGI-vars, will be set manually:
 * REDIRECT_STATUS
 * DOCUMENT_ROOT
 * PATH
 */


/* work around glibc overhead and dietlibc limitations */
#ifndef uid32_t
typedef uint32_t uid32_t;
#endif
#ifndef gid32_t
typedef uint32_t gid32_t;
#endif
#ifdef NULLDEF
static uid32_t mygetuid() {
  int res = syscall(__NR_getuid32);
  if (res == -1 && errno == ENOSYS) { /* 38 */
    res = syscall(__NR_getuid);
  }
  return (uid32_t) res;
}
#endif
static int mysetuid(uid32) {
  int res = syscall(__NR_setuid32, uid32);
  if (res == -1 && errno == ENOSYS) { /* 38 */
    res = syscall(__NR_setuid, (uint16_t) uid32);
  }
  return res;
}
static int mysetgid(gid32) {
  int res = syscall(__NR_setgid32, gid32);
  if (res == -1 && errno == ENOSYS) { /* 38 */
    res = syscall(__NR_setgid, (uint16_t) gid32);
  }
  return res;
}



/*
#define UT_NAMESIZE 32
#define UT_GROUPSIZE 32

#define ERR_TO_BROWSER 1
#define SNL     256
#define ENVPATH 8196

#define APACHE_UID 81
#define APACHE_GID 81

#define PATHTOSUPHP "/usr/sbin/suphp"
#define SUPHP "suphp"

#define PATHTOPHP "/usr/bin/php"

#define DEFAULT_PATH "/bin:/usr/bin:/usr/local/bin:/usr/sbin:/usr/local/typo3sh/bin"

#define USERGID 100

*/

// echo '2^64' |bc|wc -c
#define INTSTRINGSIZE 21

extern char **environ;


/**
 * PD by Daniel J. Bernstein:
 * alloc()/alloc_free()
 */
#define ALIGNMENT 16 /* XXX: assuming that this alignment is enough */
#define SPACE 65536 /* must be multiple of ALIGNMENT */

typedef union { char irrelevant[ALIGNMENT]; double d; } aligned;
static aligned realspace[SPACE / ALIGNMENT];
#define space ((char *) realspace)
static unsigned int avail = SPACE; /* multiple of ALIGNMENT; 0<=avail<=SPACE */

void *alloc(size_t n) {
  char *x;
  n = ALIGNMENT + n - (n & (ALIGNMENT - 1)); /* XXX: could overflow */
  if (n <= avail) { avail -= n; return space + avail; }
  x = malloc(n);
  /* if (!x) errno = error_nomem; */
  if (!x) errno = 127;
  return x;
}

#ifdef NULLDEF
void alloc_free(char *x) {
  if (x >= space)
    if (x < space + SPACE)
      return; /* XXX: assuming that pointers are flat */
  free(x);
}
#endif

/*
int lsuphp_setenv(const char *name, const char *value, int overwrite) {
  if (getenv(name)) {
    if (!overwrite) return 0;
    unsetenv(name);
  }
  {
    register char *c=alloc(strlen(name)+strlen(value)+2);
    char *p = c;
    c = stpcpy(c,name);
    *c = '='; ++c;
    strcat(c,"=");
    c = stpcpy(c,value);
    return putenv(p);
  }
}
*/

/*
static char *runtime[INTSTRINGSIZE+1];
unsigned int realtime;
void sulog(const char *fmt,...) {
   va_list ap;
   va_start(ap, fmt);
       vsyslog(LOG_INFO, fmt, ap);
   va_end(ap);
}
int suphp_setenv(const char *name, const char *value, int overwrite) {
    char *putstr = NULL;
    char *temp = NULL;
    int retval = 0;

    if (!overwrite && getenv(name) != NULL)
        return 0;
    temp = NULL;
    putstr = calloc(strlen(name) + strlen(value) + 1,sizeof(char));
    if (putstr == NULL) { exit(1); }
    strncpy(putstr, name,strlen(name));
    temp = putstr + strlen(name);
    *temp = '=';
    temp++;
    strncpy(temp, value,strlen(value));
    retval = putenv(putstr);
    return retval;
}
*/

/*
void exec_script(char* scriptname)
{
 char *php_config;
 char *env;

 // Set the enviroment (for compatibility reasons)

 // suphp-0.7.1/src/Application.cpp:86:            scriptFilename = env.getVar("SCRIPT_FILENAME");
 if (getenv("SCRIPT_FILENAME") == NULL)
 {
  error_msg_exit(ERRCODE_WRONG_ENVIRONMENT, "SCRIPT_FILENAME is not set", __FILE__, __LINE__);
 }
 env = strdup(getenv("SCRIPT_FILENAME"));
 suphp_setenv("PATH_TRANSLATED", env, 1);
 free(env);

 env = NULL;

 suphp_setenv("REDIRECT_STATUS", "200", 1); // PHP may need this

 // Set secure PATH

 suphp_setenv("PATH", "/bin:/usr/bin", 1);

 // Check for PHP_CONFIG environment variable

 if (getenv("PHP_CONFIG"))
 {
  if ((php_config = strdup(getenv("PHP_CONFIG")))==NULL)
   error_sysmsg_exit(ERRCODE_UNKNOWN, "strdup() failed", __FILE__, __LINE__);
  suphp_setenv("PHPRC", php_config, 1);
  free(php_config);
  php_config = NULL;
  suphp_unsetenv("PHP_CONFIG");
 }

#if (defined(OPT_USERGROUP_FORCE) || defined(OPT_USERGROUP_PARANOID))
 suphp_unsetenv("PHP_SU_USER");
 suphp_unsetenv("PHP_SU_GROUP");
#endif

 // Exec PHP
 execl(OPT_PATH_TO_PHP, OPT_PATH_TO_PHP, NULL);

 // Should never be reached
 error_sysmsg_exit(ERRCODE_UNKNOWN, "execl() failed", __FILE__, __LINE__);
}

int suphp_passwdcpy(struct passwd *target, struct passwd *source)
{
 if (!target || !source)
  return 0;

 if (source->pw_name)
 {
  target->pw_name = strdup(source->pw_name);
  if (!target->pw_name)
   return 0;
 }
 else
  target->pw_name = NULL;

 // target->pw_passwd is never needed
 target->pw_passwd = NULL;

 target->pw_uid = source->pw_uid;

 target->pw_gid = source->pw_gid;

 // target->pw_gecos is never needed
 target->pw_gecos = NULL;

 // target->pw_dir is never needed
 target->pw_dir = NULL;

 // target->pw_shell is never needed
 target->pw_shell = NULL;

 return 1;
}

int suphp_groupcpy(struct group *target, struct group *source)
{
 if (!target || !source)
  return 0;

 if (source->gr_name)
 {
  target->gr_name = strdup(source->gr_name);
  if (!target->gr_name)
   return 0;
 }
 else
  target->gr_name = NULL;

 // target->gr_passwd is never needed
 target->gr_passwd = NULL;

 target->gr_gid = source->gr_gid;

 // target->gr_mem is never needed
 target->gr_mem = NULL;

 return 1;
}
*/

static void sulog(const char *msg1, const char *msg2) {
  register char *p;
  char buf[PATH_MAX*2+1];
  p = stpcpy(buf, msg1);
  if (msg2) {
    p = stpcpy(p,": ");
    strncpy(p, msg2, PATH_MAX);
    p += strlen(p);
  }
  *p = '\n'; ++p;
  *p = 0;
  /* syslog(LOG_INFO, "%s", buf); */
  write(2, buf, p-buf);
  return;
}

/*
int main(int argc,char **argv) {
  register char *p;

    struct passwd *pw;

    unsigned int fd, fd_max;
    uid_t uid_user;
    gid_t gid_user;

  openlog("suphp",LOG_PID|LOG_NDELAY,LOG_LOCAL0);

#ifdef NULLDEF
    // check if were are called from apache
    if ((pw = getpwuid(APACHE_UID)) == NULL) {
       sulog("could not get the pwentry for the apache user uid %d. Error :%s",
             APACHE_UID,strerror(errno));
       exit(-1);
    }

    if ((getuid() != pw->pw_uid) && (getgid() != pw->pw_gid)) {
           sulog("only the %s user is allowed to call %s.",
                 pw->pw_name,argv[0]);
           fprintf(stderr,"only the %s user is allowed to call %s.(suphp must be called from mod_suphp).\n",
                   pw->pw_name,argv[0]);
           exit(-1);
    }
#endif
*/

/*
  if (getuid() != APACHE_UID) { sulog("user not allowed to execute suphp\n"); _exit(1); }
  if (getgid() != APACHE_GID) { sulog("group not allowed to execute suphp\n"); _exit(2); }
*/

int main(int argc,char **argv) {
  register char *p;
  int i;
  struct stat64 st;
  struct stat64 st2;
  const char *pwdbuf;
  off_t pwdlen;
  uint32_t ulen;
  uint32_t uid, gid;
  char *cgienv[sizeof(cgivars)/sizeof(char*)];
  int chrooted = 0;
  char cwd[PATH_MAX+1];
  char homedir[PATH_MAX+1];
  char scriptfilenamepath[PATH_MAX*2+1];
  char *docroot;
#include <stdio.h>
FILE *out;


out = fopen("/tmp/lsuphp.log", "a");
  openlog("suphp",LOG_PID|LOG_NDELAY,LOG_LOCAL0);


  if (lstat64(PATHTOSUPHP, &st) < 0) { sulog("can't lstat suphp", PATHTOSUPHP); _exit(3); }
  if (S_ISLNK(st.st_mode)) {   sulog("suphp must not be a symlink", PATHTOSUPHP); _exit(4); }
  if (!S_ISREG(st.st_mode)) { sulog("suphp is not a regular file", PATHTOSUPHP); _exit(5); }

#include <stdio.h>
printf("Content-type: text/plain\n\n");
  {
    // get cwd and stat(argv0)
    char path_to_argv0[PATH_MAX*2+2];
    p = getcwd(cwd, PATH_MAX);
    if (!p) { sulog("can't get wd", 0); _exit(6); }
    p = stpcpy(path_to_argv0, p);
    *p = '/'; ++p;
    strncpy(p, argv[0], PATH_MAX);
strncpy(path_to_argv0, argv[0], PATH_MAX);
/* stat64("/home/aschuerh/www/cgi-bin//home/aschuerh/www/cgi-bin/lsuphp.orig", */
fprintf(out, "path_to_argv0=%s\nargv0=%s\n", path_to_argv0, argv[0]);
/*
    if (stat64(path_to_argv0, &st2) < 0) { sulog("can't stat() argv0", argv[0]); _exit(7); }
*/
if (stat64(path_to_argv0, &st2) < 0) fprintf(out,"can't stat() path_to_argv0=%s, argv0=%s\n", path_to_argv0, argv[0]);
  }

  // compare both stats, argv0 and PATHTOSUPHP, be paranoid, check also rdev and size
  if ((st.st_dev != st2.st_dev) ||
      (st.st_ino != st2.st_ino) ||
      (st.st_rdev != st2.st_rdev) ||
      (st.st_size != st2.st_size)) {
/*
    sulog("argv0 is the wrong suphp binary", argv[0]);
*/

fprintf(out,"argv0 is the wrong suphp binary");
/*
    _exit(8);
*/
  }

  p = getenv("SCRIPT_FILENAME");
  if (!p) { sulog("SCRIPT_FILENAME unset", 0); _exit(9); }

  // get absolute path to SCRIPT_FILENAME
  if (strchr(p, '/')) {
    // webserver delivers SCRIPT_FILENAME with full path (i.e. apache)
    strcpy(scriptfilenamepath, p);
  } else {
    // webserver delivers SCRIPT_FILENAME as filename in cwd (i.e. fnord/kerkelinn)
    char *tmp = stpcpy(scriptfilenamepath, cwd);
    *tmp = '/'; ++tmp;
    strncpy(tmp, p, PATH_MAX);
    scriptfilenamepath[PATH_MAX] = 0;
  }

fprintf(out,"scriptfilenamepath=%s\ncwd=%s\n",scriptfilenamepath,cwd);
  /* printf("scriptfilenamepath=%s\ncwd=%s\n",scriptfilenamepath,cwd); */

  i = 0;
  for(;;) {
    if (!allowed_suffixes[i]) {
      sulog("script filename suffix not allowed", scriptfilenamepath);
      _exit(9);
    }
    if (!str_diff_right(scriptfilenamepath, allowed_suffixes[i])) break;
    ++i;
  }
  /* printf("suffix detected: %s\n", allowed_suffixes[i]); */

  if (stat64(scriptfilenamepath, &st) < 0) { sulog("can't stat() scriptfilename", scriptfilenamepath); _exit(10); }
  if (lstat64(scriptfilenamepath, &st2) < 0) { sulog("can't lstat() scriptfilename", scriptfilenamepath); _exit(11); }
  uid = st.st_uid;
  gid = st.st_gid;
  if ((uid != st2.st_uid) ||
      (st.st_dev != st2.st_dev) ||
      (gid != st2.st_gid)) {
    sulog("uid/gid/dev mismatch on stat()/lstat() scriptfilename", scriptfilenamepath);
    _exit(12);
  }

  /* if (!uid) { sulog("scriptfilename not allowed as root\n"); _exit(12); } */
  if (uid <= MINUID) { sulog("scriptfilename owner uid not allowed", scriptfilenamepath); _exit(12); }
  if (gid <= MINGID) { sulog("scriptfilename group gid not allowed", scriptfilenamepath); _exit(12); }
  if (st.st_mode & S_IWOTH) { sulog("scriptfilename is world writeable", scriptfilenamepath); _exit(13); }

  /* get homedir */
  p = (char *) map_passwd_file(&pwdbuf, &pwdlen);
  if (p == (char *) -1) {
    sulog("can't read/mmap /etc/passwd", 0);
    _exit(14);
  }
  p = (char *) get_home_from_passwd(pwdbuf, pwdlen, uid, &ulen);
  if (!p) {
    munmap((void *) pwdbuf, pwdlen);
    sulog("can't get homedir from /etc/passwd", 0);
    _exit(14);
  }
  strncpy(homedir, p, ulen);
  munmap((void *) pwdbuf, pwdlen);
  p = homedir;

  /* printf("homedir %s\n", homedir); */

  /* check homedir string for chroot hack string "/./" */
  if (*p != '/') { sulog("illegal homedir", homedir); _exit(15); }
  ++p;
  for(;;) {
    if (!*p) break;
    if (*p == '/') {
      for(;;) { ++p; if (*p != '/') break; }
      if (*p != '.') continue;
      ++p;
      if (*p != '/') continue;
      chrooted = 1;
      break;
    }
    ++p;
  }
  /* if (!*p) printf("no chroot\n"); */

  /* rebuild environment */
  i = 0;
  cgienv[i] = "PATH=" PATHENV; ++i;
  docroot = getenv("DOCUMENT_ROOT");
  if (!docroot) docroot = "/";
  p = alloc(strlen(docroot) + 15);
  cgienv[i] = p;
  p = stpcpy(p, "DOCUMENT_ROOT=");
  stpcpy(p, docroot);
  ++i;
  /* on php force_cgi_redirect: */
  p = getenv("REDIRECT_STATUS");
  if (!p) {
    cgienv[i] = "REDIRECT_STATUS=200";
  } else {
    char *tmprs = p;
    p = alloc(strlen(tmprs) + 17);
    cgienv[i] = p;
    p = stpcpy(p, "REDIRECT_STATUS=");
    stpcpy(p, tmprs);
  }
  ++i;
  {
    char *tmpenv;
    for (;;) {
      if (!cgivars[i]) { cgienv[i] = 0; break; }
      p = getenv(cgivars[i]);
      if (!p) {
        sulog("missing CGI var", cgivars[i]);
        continue;
        /*_exit(16);*/
      }
      tmpenv = p;
      p = alloc(strlen(tmpenv) + strlen(cgivars[i]) + 2);
      cgienv[i] = p;
      p = stpcpy(p, cgivars[i]);
      *p = '='; ++p;
      stpcpy(p, tmpenv);
      ++i;
    }
  }

  if (chrooted) {
    if (chroot(homedir) < 0) {
      sulog("can't chroot", homedir);
      _exit(17);
    }
    closelog();
    /* don't be fooled: linux chroot() doesn't make chdir() */
    if (chdir("/") < 0) _exit(18);
  } else {
    if (chdir(homedir) < 0) {
      sulog("can't cd", homedir);
      _exit(17);
    }
  }

  /* be paranoid: check scriptfile in chroot again */
  if (stat64(scriptfilenamepath, &st2) < 0) _exit(19);
  if ((uid != st2.st_uid) ||
      (st.st_dev != st2.st_dev) ||
      (gid != st2.st_gid)) {
    _exit(20);
  }
  if (st.st_mode & S_IWOTH) { sulog("scriptfilename is world writeable", scriptfilenamepath); _exit(21); }

  /* now switch ids */
  if (mysetgid(gid) < 0) _exit(22);
  if (mysetuid(uid) < 0) _exit(23);

  if (docroot) {
    if (chdir(docroot) < 0) _exit(24);
  }

fclose(out);
  argv[0] = scriptfilenamepath;
  argv[1] = 0;
  if (execve(PATHTOPHP, argv, cgienv) < 0) {
  }
  _exit(100);
}

/*
int main(int argc, char* argv[])
{
 // Check, if program has been started by Apache
 struct passwd apacheuser;
 struct passwd calluser;
 struct passwd targetuser;
 struct group targetgroup;
 struct passwd *ptruser;
 struct group *ptrgroup;

#if (defined(OPT_USERGROUP_FORCE) || defined(OPT_USERGROUP_PARANOID))
 char *envusername = NULL;
 char *envgroupname = NULL;
#endif

#ifdef OPT_USERGROUP_PARANOID
 struct passwd envuser;
 struct group envgroup;
#endif

#ifdef OPT_NO_PASSWD
 // Declare empty structure for user
 struct passwd emptyuser;
 // Declare variable for information whether to use supplementary groups
 int use_supp_groups = 1;
#endif

#ifdef OPT_NO_GROUP
 // Declare emtpy structure for group
 struct group emptygroup;
#endif

 char *path_translated = NULL;

#ifdef OPT_NO_PASSWD
 // Initialize structure
 emptyuser.pw_name = "";
 emptyuser.pw_passwd = "";
 emptyuser.pw_uid = 65534;
 emptyuser.pw_gid = 65534;
 emptyuser.pw_gecos = "";
 emptyuser.pw_dir = "/dev/null";
 emptyuser.pw_shell = "/bin/false";
#endif

#ifdef OP_NO_GROUP
 // Initialize structure
 emptygroup.gr_name = "";
 emptygroup.gr_passwd = "";
 emptygroup.gr_gid = 65534;
 emptygroup.gr_mem = NULL;
#endif

 // Open logfile
 suphp_init_log();

 // suphp-0.7.1/src/Application.cpp:86:            scriptFilename = env.getVar("SCRIPT_FILENAME");
 if(getenv("SCRIPT_FILENAME") != NULL)
  path_translated = strdup(getenv("SCRIPT_FILENAME"));
 else
  error_msg_exit(ERRCODE_WRONG_ENVIRONMENT, "SCRIPT_FILENAME is not set", __FILE__, __LINE__);

 if ((ptruser = getpwnam(OPT_APACHE_USER))==NULL)
 {
  suphp_log_error("Could not get passwd information for Apache user (%s)", OPT_APACHE_USER);
  error_sysmsg_exit(ERRCODE_UNKNOWN, "getpwnam() failed", __FILE__, __LINE__);
 }
 if (!suphp_passwdcpy(&apacheuser, ptruser))
 {
  error_sysmsg_exit(ERRCODE_UNKNOWN, "Could not copy struct passwd", __FILE__, __LINE__);
 }

 if ((ptruser = getpwuid(getuid()))==NULL)
 {
  suphp_log_error("Could not get passwd information for calling UID %d", getuid());
  error_sysmsg_exit(ERRCODE_UNKNOWN, "getpwuid() failed", __FILE__, __LINE__);
 }
 if (!suphp_passwdcpy(&calluser, ptruser))
 {
  error_sysmsg_exit(ERRCODE_UNKNOWN, "Could not copy struct passwd", __FILE__, __LINE__);
 }


 if (calluser.pw_uid!=apacheuser.pw_uid)
 {
  suphp_log_error("suPHP was called by %s (%d), not by %s (%d)", calluser.pw_name, calluser.pw_uid, apacheuser.pw_name, apacheuser.pw_uid);
  error_msg_exit(ERRCODE_WRONG_PARENT, "UID of calling process mismatches", __FILE__, __LINE__);
 }

#ifdef OPT_CHECKPATH
 // Is the script in the DOCUMENT_ROOT?
 if(!check_path(path_translated))
 {
  suphp_log_error("Script %s is not in the DOCUMENT_ROOT (%s)", path_translated, getenv("DOCUMENT_ROOT"));
  error_msg_exit(ERRCODE_WRONG_PATH, "Script is not in document root", __FILE__, __LINE__);
 }
#endif

 // Does the script exist?
 if(!file_exists(path_translated))
 {
  suphp_log_error("File %s not found", path_translated);
  error_msg_exit(ERRCODE_FILE_NOT_FOUND, "Script not found", __FILE__, __LINE__);
 }
 // Check permissions for the script
 if(!check_permissions(path_translated))
  error_msg_exit(ERRCODE_WRONG_PERMISSIONS, "Inappropriate permissions set on script", __FILE__, __LINE__);

#if (defined(OPT_USERGROUP_FORCE) || defined(OPT_USERGROUP_PARANOID))
 if (getenv("PHP_SU_USER") != NULL)
  envusername = strdup(getenv("PHP_SU_USER"));
 else
  error_msg_exit(ERRCODE_WRONG_ENVIRONMENT, "PHP_SU_USER is not set", __FILE__, __LINE__);

 if ((ptruser = getpwnam(envusername)) == NULL)
 {
  suphp_log_error("getpwnam() for user %s failed", envusername);
  error_msg_exit(ERRCODE_UNKNOWN, "getpwnam() failed", __FILE__, __LINE__);
 }
 else
 {
#ifdef OPT_USERGROUP_PARANOID
  if (!suphp_passwdcpy(&envuser, ptruser))
  {
   error_sysmsg_exit(ERRCODE_UNKNOWN, "Could not copy struct passwd", __FILE__, __LINE__);
  }

#endif
#ifdef OPT_USERGROUP_FORCE
  if (!suphp_passwdcpy(&targetuser, ptruser))
  {
   error_sysmsg_exit(ERRCODE_UNKNOWN, "Could not copy struct passwd", __FILE__, __LINE__);
  }

#endif
  free(envusername);
  envusername = NULL;
 }
#endif

#if (defined(OPT_USERGROUP_OWNER) || defined(OPT_USERGROUP_PARANOID))
 // Get gid and uid of the file and check it
 if ((ptruser = getpwuid(file_get_uid(path_translated)))==NULL)
 {
#ifdef OPT_NO_PASSWD
  emptyuser.pw_uid = file_get_uid(path_translated);
  emptyuser.pw_gid = file_get_gid(path_translated);
  emptyuser.pw_name = "NOT AVAILABLE";
  if (!suphp_passwdcpy(&targetuser, &emptyuser))
  {
   error_sysmsg_exit(ERRCODE_UNKNOWN, "Could not copy struct passwd", __FILE__, __LINE__);
  }

  use_supp_groups = 0;
#else
  suphp_log_error ("Could not get passwd information for UID %d", file_get_uid(path_translated));
  error_sysmsg_exit(ERRCODE_UNKNOWN, "getpwuid() failed", __FILE__, __LINE__);
#endif
 }
 else
 {
  if (!suphp_passwdcpy(&targetuser, ptruser))
  {
   error_sysmsg_exit(ERRCODE_UNKNOWN, "Could not copy struct passwd", __FILE__, __LINE__);
  }

 }
#endif

 if (targetuser.pw_uid < OPT_MIN_UID)
 {
  suphp_log_error("UID of %s or its target (%d / %s) < %d", path_translated, targetuser.pw_uid, targetuser.pw_name, OPT_MIN_UID);
  error_msg_exit(ERRCODE_LOW_UID, "User is not allowed to run scripts", __FILE__, __LINE__);
 }

#ifdef OPT_USERGROUP_PARANOID
 if (targetuser.pw_uid != envuser.pw_uid)
 {
  suphp_log_error("UID of owner of %s or its target (%d / %s) mismatches target UID specified in configuration (%d / %s)", path_translated, targetuser.pw_uid, targetuser.pw_name, envuser.pw_uid, envuser.pw_name);
  error_msg_exit(ERRCODE_WRONG_UID, "Script has wrong UID", __FILE__, __LINE__);
 }
#endif

#if (defined(OPT_USERGROUP_FORCE) || defined(OPT_USERGROUP_PARANOID))
 if (getenv("PHP_SU_GROUP") != NULL)
  envgroupname = strdup(getenv("PHP_SU_GROUP"));
 else
  error_msg_exit(ERRCODE_WRONG_ENVIRONMENT, "PHP_SU_GROUP is not set", __FILE__, __LINE__);

 if ((ptrgroup = getgrnam(envgroupname)) == NULL)
 {
  suphp_log_error("getgrnam() for group %s failed", envgroupname);
  error_msg_exit(ERRCODE_UNKNOWN, "getgrnam() failed", __FILE__, __LINE__);
 }
 else
 {
#ifdef OPT_USERGROUP_PARANOID
  memcpy(&envgroup, ptrgroup, sizeof(struct group));
  if (!suphp_groupcpy(&envgroup, ptrgroup))
  {
   error_sysmsg_exit(ERRCODE_UNKNOWN, "Could not copy struct group", __FILE__, __LINE__);
  }
#endif

#ifdef OPT_USERGROUP_FORCE
  memcpy(&targetgroup, ptrgroup, sizeof(struct group));
  if (!suphp_groupcpy(&targetgroup, ptrgroup))
  {
   error_sysmsg_exit(ERRCODE_UNKNOWN, "Could not copy struct group", __FILE__, __LINE__);
  }

#endif
  free(envgroupname);
 }
#endif

#if (defined(OPT_USERGROUP_OWNER) || defined(OPT_USERGROUP_PARANOID))
 if ((ptrgroup = getgrgid(file_get_gid(path_translated)))==NULL)
 {
#ifdef OPT_NO_GROUP
  emptygroup.gr_gid = file_get_gid(path_translated);
  emptygroup.gr_name = "NOT AVAILABLE";
  memcpy(&targetgroup,  &emptygroup, sizeof(struct group));
  if (!suphp_groupcpy(&targetgroup, &emptygroup))
  {
   error_sysmsg_exit(ERRCODE_UNKNOWN, "Could not copy struct group", __FILE__, __LINE__);
  }

#else
  suphp_log_error ("Could not get group information for GID %d", file_get_gid(path_translated));
  error_msg_exit(ERRCODE_UNKNOWN, "getgrgid() failed", __FILE__, __LINE__);
#endif
 }
 else
 {
  if (!suphp_groupcpy(&targetgroup, ptrgroup))
  {
   error_sysmsg_exit(ERRCODE_UNKNOWN, "Could not copy struct group", __FILE__, __LINE__);
  }

 }
#endif

 if (targetgroup.gr_gid < OPT_MIN_GID)
 {
  suphp_log_error ("GID of %s or its target (%d / %s) < %d", path_translated, targetgroup.gr_gid, targetgroup.gr_name, OPT_MIN_GID);
  error_msg_exit(ERRCODE_LOW_GID, "Group is not allowed to run scripts", __FILE__, __LINE__);
 }

#ifdef OPT_USERGROUP_PARANOID
 if (targetgroup.gr_gid != envgroup.gr_gid)
 {
  suphp_log_error("GID of group-owner of %s or its target (%d / %s) mismatches target GID specified in configuration (%d / %s)", path_translated, targetgroup.gr_gid, targetgroup.gr_name, envgroup.gr_gid, envgroup.gr_name);
  error_msg_exit(ERRCODE_WRONG_GID, "Script has wrong GID", __FILE__, __LINE__);
 }
#endif

#if (defined(OPT_USERGROUP_OWNER) || defined(OPT_USERGROUP_PARANOID))
 // Check if file is a symbollink
 if (file_is_symbollink(path_translated))
 {
  // Get gid and uid of the symbollink and check if it matches to the target
  if (targetuser.pw_uid != file_get_uid_l(path_translated))
  {
   suphp_log_error ("UID of symbollink %s does not match its target", path_translated);
   error_msg_exit(ERRCODE_SYMBOLLINK_NO_MATCH, "Symbol link UID mismatches target's UID", __FILE__, __LINE__);
  }
  if (targetgroup.gr_gid != file_get_gid_l(path_translated))
  {
   suphp_log_error ("GID of symbollink %s does not match its target", path_translated);
   error_msg_exit(ERRCODE_SYMBOLLINK_NO_MATCH, "Symbol link GID mismatches target'S GID", __FILE__, __LINE__);
  }
 }
#endif

 // We have to create the log entry before losing root privileges
 suphp_log_info("Executing %s as user %s (%d), group %s (%d)", path_translated, targetuser.pw_name, targetuser.pw_uid, targetgroup.gr_name, targetgroup.gr_gid);

 // Set gid and uid
 if (setgid(targetgroup.gr_gid))
 {
  suphp_log_error("Could not change GID to %d (%s)", targetgroup.gr_gid, targetgroup.gr_name);
  error_sysmsg_exit(ERRCODE_UNKNOWN, "setgid() failed", __FILE__, __LINE__);
 }

 // Initialize supplementary groups for user
#ifdef OPT_NO_PASSWD
 if (use_supp_groups && initgroups(targetuser.pw_name, targetuser.pw_gid))
 {
  suphp_log_error("Could not initialize supplementary groups for user %s (%d)", targetuser.pw_name, targetuser.pw_uid);
  error_sysmsg_exit(ERRCODE_UNKNOWN, "initgroups() failed", __FILE__, __LINE__);
 }
 if (!use_supp_groups)
 {
  if (setgroups(0, NULL))
  {
   suphp_log_error("Could not set supplementary groups to null");
   error_sysmsg_exit(ERRCODE_UNKNOWN, "setgroups() failed", __FILE__, __LINE__);
  }
 }
#else
 if (initgroups(targetuser.pw_name, targetuser.pw_gid))
 {
  suphp_log_error("Could not initialize supplementary groups for user %s (%d)", targetuser.pw_name, targetuser.pw_uid);
  error_sysmsg_exit(ERRCODE_UNKNOWN, "initgroups() failed", __FILE__, __LINE__);
 }
#endif


 if (setuid(targetuser.pw_uid))
 {
  suphp_log_error("Could not change UID to %d (%s)", targetuser.pw_uid, targetuser.pw_name);
  error_sysmsg_exit(ERRCODE_UNKNOWN, "setuid() failed", __FILE__, __LINE__);
 }

 // Execute the script with PHP
 exec_script(path_translated);

 // Still here? This cannot be right...
 suphp_log_error("Error on exec() PHP for %s", path_translated);
 error_exit(ERRCODE_UNKNOWN);
 return ERRCODE_UNKNOWN;
}
*/

/*

Environment and PHP Variables Apache

Environment
Variable	Value
HOSTNAME 	treferpol.tuxad.net
SHELL 	/bin/bash
TERM 	xterm-color
HISTSIZE 	10000
SSH_CLIENT 	87.245.9.198 59761 22
SSH_TTY 	/dev/pts/3
USER 	frankb
HISTFILESIZE 	100000
LS_COLORS 	no=00:....
PATH 	/sbin:/usr/sbin:/bin:/usr/bin
MAIL 	/var/spool/mail/frankb
PWD 	/var/www/html
INPUTRC 	/etc/inputrc
LANG 	C
SSH_ASKPASS 	/usr/libexec/openssh/gnome-ssh-askpass
HOME 	/root
SHLVL 	4
LOGNAME 	frankb
SSH_CONNECTION 	87.245.9.198 59761 81.89.239.233 22
LESSOPEN 	|/usr/bin/lesspipe.sh %s
G_BROKEN_FILENAMES 	1
_ 	/usr/sbin/httpd
KRB5RCACHETYPE 	none

PHP Variables
Variable	Value
_SERVER["HTTP_HOST"]	www.XXXX.net
_SERVER["HTTP_USER_AGENT"]	Mozilla/5.0 (Macintosh; U; PPC Mac OS X 10.4; de; rv:1.9.2.17) Gecko/20110420 Firefox/3.6.17
_SERVER["HTTP_ACCEPT"]	text/html,application/xhtml+xml,application/xml;q=...
_SERVER["HTTP_ACCEPT_LANGUAGE"]	de-de,de;q=0.8,en-us;q=0.5,en;q=0.3
_SERVER["HTTP_ACCEPT_ENCODING"]	gzip,deflate
_SERVER["HTTP_ACCEPT_CHARSET"]	ISO-8859-1,utf-8;q=0.7,*;q=0.7
_SERVER["HTTP_KEEP_ALIVE"]	115
_SERVER["HTTP_DNT"]	1
_SERVER["HTTP_CONNECTION"]	keep-alive
_SERVER["PATH"]	/sbin:/usr/sbin:/bin:/usr/bin
_SERVER["SERVER_SIGNATURE"]	<address>Apache/2.2.3 (Red Hat) Server at www.XXXX.net Port 80</address>
_SERVER["SERVER_SOFTWARE"]	Apache/2.2.3 (Red Hat)
_SERVER["SERVER_NAME"]	www.XXXX.net
_SERVER["SERVER_ADDR"]	81.89.239.233
_SERVER["SERVER_PORT"]	80
_SERVER["REMOTE_ADDR"]	87.245.9.198
_SERVER["DOCUMENT_ROOT"]	/var/www/html
_SERVER["SERVER_ADMIN"]	webmaster@XXXX.net
_SERVER["SCRIPT_FILENAME"]	/var/www/html/iii.php
_SERVER["REMOTE_PORT"]	59802
_SERVER["GATEWAY_INTERFACE"]	CGI/1.1
_SERVER["SERVER_PROTOCOL"]	HTTP/1.1
_SERVER["REQUEST_METHOD"]	GET
_SERVER["QUERY_STRING"]	no value
_SERVER["REQUEST_URI"]	/iii.php
_SERVER["SCRIPT_NAME"]	/iii.php
_SERVER["PHP_SELF"]	/iii.php
_SERVER["REQUEST_TIME"]	1307861951
_SERVER["argv"]	

Array
_SERVER["argc"]	0
_ENV["HOSTNAME"]	treferpol.XXXX.net
_ENV["SHELL"]	/bin/bash
_ENV["TERM"]	xterm-color
_ENV["HISTSIZE"]	10000
_ENV["SSH_CLIENT"]	87.245.9.198 59761 22
_ENV["SSH_TTY"]	/dev/pts/3
_ENV["USER"]	frankb
_ENV["HISTFILESIZE"]	100000
_ENV["LS_COLORS"]	no=00:...
_ENV["PATH"]	/sbin:/usr/sbin:/bin:/usr/bin
_ENV["MAIL"]	/var/spool/mail/frankb
_ENV["PWD"]	/var/www/html
_ENV["INPUTRC"]	/etc/inputrc
_ENV["LANG"]	C
_ENV["SSH_ASKPASS"]	/usr/libexec/openssh/gnome-ssh-askpass
_ENV["HOME"]	/root
_ENV["SHLVL"]	4
_ENV["LOGNAME"]	frankb
_ENV["SSH_CONNECTION"]	87.245.9.198 59761 81.89.239.233 22
_ENV["LESSOPEN"]	|/usr/bin/lesspipe.sh %s
_ENV["G_BROKEN_FILENAMES"]	1
_ENV["_"]	/usr/sbin/httpd
_ENV["KRB5RCACHETYPE"]	none



Environment and PHP Variables fnord/kerkelinn

Environment
Variable	Value
GATEWAY_INTERFACE 	CGI/1.1
SERVER_PROTOCOL 	HTTP/1.0
SERVER_SOFTWARE 	kerkelinn/1.13.1
SERVER_NAME 	www.XXX.de:80
SERVER_PORT 	80
REQUEST_METHOD 	GET
REQUEST_URI 	/iii.php
SCRIPT_NAME 	/iii.php
HTTP_HOST 	www.XXX.de:80
REMOTE_ADDR 	87.245.9.198
REMOTE_PORT 	59796
HTTP_USER_AGENT 	Mozilla/5.0 (Macintosh; U; PPC Mac OS X 10.4; de; rv:1.9.2.17) Gecko/20110420 Firefox/3.6.17
HTTP_ACCEPT_ENCODING 	gzip,deflate
SCRIPT_FILENAME 	iii.php
REDIRECT_STATUS 	200
GID 	93
UID 	93
PROTO 	TCP
TCPLOCALIP 	81.89.239.234
TCPLOCALPORT 	80
TCPLOCALHOST 	localhost
TCPREMOTEIP 	87.245.9.198
TCPREMOTEPORT 	59796

PHP Variables
Variable	Value
_SERVER["GATEWAY_INTERFACE"]	CGI/1.1
_SERVER["SERVER_PROTOCOL"]	HTTP/1.0
_SERVER["SERVER_SOFTWARE"]	kerkelinn/1.13.1
_SERVER["SERVER_NAME"]	www.XXX.de:80
_SERVER["SERVER_PORT"]	80
_SERVER["REQUEST_METHOD"]	GET
_SERVER["REQUEST_URI"]	/iii.php
_SERVER["SCRIPT_NAME"]	/iii.php
_SERVER["HTTP_HOST"]	www.XXX.de:80
_SERVER["REMOTE_ADDR"]	87.245.9.198
_SERVER["REMOTE_PORT"]	59796
_SERVER["HTTP_USER_AGENT"]	Mozilla/5.0 (Macintosh; U; PPC Mac OS X 10.4; de; rv:1.9.2.17) Gecko/20110420 Firefox/3.6.17
_SERVER["HTTP_ACCEPT_ENCODING"]	gzip,deflate
_SERVER["SCRIPT_FILENAME"]	iii.php
_SERVER["REDIRECT_STATUS"]	200
_SERVER["GID"]	93
_SERVER["UID"]	93
_SERVER["PROTO"]	TCP
_SERVER["TCPLOCALIP"]	81.89.239.234
_SERVER["TCPLOCALPORT"]	80
_SERVER["TCPLOCALHOST"]	localhost
_SERVER["TCPREMOTEIP"]	87.245.9.198
_SERVER["TCPREMOTEPORT"]	59796
_SERVER["PHP_SELF"]	/iii.php
_SERVER["REQUEST_TIME"]	1307861658

*/
