/**
 * myslowuserfilter.c
 */

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <features.h>
#include "../lib/libfwb.h"
#include "../lib/buffer.h"
#include <stdint.h>
#include <time.h>

#define READBUFSIZE 131072
char buf0space[READBUFSIZE+1];
#define WRITEBUFSIZE 131072
char buf1space[WRITEBUFSIZE+1];
#define LINEBUFSIZE 524288

uint32_t read_line(buffer *b, register char *buf, uint32_t buflen) {
  register char *p;
  register int c;
  register int l;
  register ssize_t n;

  p = b->c;
  if (!p) return 0;
  --buflen;
  l = 0;

  for(;;) {

    if (p < b->t) goto get;
    p = b->s;
    n = read(0, p, b->l);
    if (n <= 0) {
      b->c = 0; /* EOF */
      goto eof_and_more;
    }
    b->t = p + n;

    get:
    c = (int) (unsigned char) (*p);
    ++p;
    b->c = p;

    if (l < buflen) {
      buf[l] = c;
      ++l;
    }
    if (c == '\n') {
      buf[l] = 0;
      break;
    }

  }

  return l;

  eof_and_more:
  if (l < buflen) {
    buf[l] = '\n';
    ++l;
  }
  return l;
}

/*
 * # Time: 111111  8:13:18
 * # User@Host: u1339[u1339] @  [172.30.132.31]
 * # Thread_id:
 * # Query_time:
 */

int main(int argc,char *const argv[]) {
  register char *p;
  register int l;
  int linetime;
  int printon;
  char line1[LINEBUFSIZE+1];
  char line2[LINEBUFSIZE+1];
  char user[READBUFSIZE+2];
  int userlen;

  p = buf0space; buffer buf0 = { p, p + READBUFSIZE, p + READBUFSIZE, 0, READBUFSIZE };
  p = buf1space; buffer buf1 = { p, p, p + WRITEBUFSIZE, 1 };
  linetime = printon = 0;
  if (argc != 2) _exit(1);
  strncpy(user, argv[1], READBUFSIZE);
  userlen = strlen(user);
  p = user + userlen;
  *p = '['; ++p;
  *p = 0;
  ++userlen;
  p = line1;

  for (;;) {

    l = read_line(&buf0, p, LINEBUFSIZE);
    if (!l) break;

    if ((*p == '#') && (p[1] == ' ')) {
      if ((p[2] == 'T') && (p[3] == 'i')) {
        linetime = 1;
        p = line2;
        continue;
      }
      if ((p[2] == 'U') && (p[3] == 's')) {
        /* # User@Host: root[root] @ localhost [] */
        if (!strncmp(p+13, user, userlen)) {
          printon = 1;
          if (linetime) {
            buffer_putstr(&buf1, line1);
          }
          buffer_putstr(&buf1, p);
        } else printon = 0;
        linetime = 0;
        p = line1;
        continue;
      }
    } else {
      linetime = 0;
    }
    if (printon) {
      buffer_put(&buf1, p, l);
    }
  }

  buffer_flush(&buf1);
  return 0;
}
