/*
 * usleep.c
 * sleep microseconds
 * it's just a demonstration of low overhead vs. Red Hat's usleep
 * compile with: diet -Os gcc -Os -o usleep usleep.c && sstrip usleep
 * *for educational purposes* :-)
 * $Id: usleep.c 691 2017-06-04 23:12:04Z fwbergm $
 */

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <features.h>

#include <unistd.h>
#include <sysexits.h>
#include <stdint.h>

#ifndef write1
#include <sys/syscall.h>
#define write1(b,c) (syscall(__NR_write, 1, b, c))
#endif

static const char usage[]="usage: usleep MICROSECONDS\n";
static void printusage() { write1(usage, sizeof usage - 1); _exit(EX_USAGE); }

static int64_t str2uint63(const char *s) {
  register char c;
  int64_t i;

  c = *s++;
  if ((c<'0') || (c>'9')) return -1;
  i = c-'0';
  for(;;) {
    c=*s;
    if((c<'0')||(c>'9')) {
      return i;
    } else {
      i=(i*10)+c-'0';
      s++;
    }
  }
}

int main(int argc,char *const argv[]) {
  register int64_t lval;

  if (argc != 2) printusage();
  lval = str2uint63(argv[1]);
  if (lval < 0) printusage();
  _exit(usleep((useconds_t) lval));
}
