/*
 * scanc99sh.c
 * $Id: scanc99sh.c 691 2017-06-04 23:12:04Z fwbergm $
 * Frank W. Bergmann 01/2009
 */

#define _FILE_OFFSET_BITS 64

#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <ftw.h>

static const char searchstring1[] = "c99sh";
static const char searchstring2[] = "gzinflate(base64_decode";
static const char searchstring3[] = "r57shell";

#define LARGEBUF_SIZE 1048576

/**
 *
 * @param buf The http data buf for returning data.
 * @param buflen The size of the http data buf.
 * @param arg1 The file/directory to analyze.
 */
int scan_file(const char *fpath, const struct stat* sb, int typeflag) {
  register char *p;
  register char *t;
  register ssize_t rb;
  register int sl;
  int fd;
  char rbuf[LARGEBUF_SIZE+1];


  /* scan only regular files */
  if (typeflag != FTW_F) return 0;
  /* don't scan too small or too big files */
  if ((sb->st_size < 10240) ||
      (sb->st_size > 10240000)) return 0;
  fd = open(fpath, O_RDONLY);
  if (fd < 0) { write2(fpath, strlen(fpath)); write2(" err\n", 5); return 1; }

  for(;;) {

    p = rbuf;
    rb = read(fd, p, LARGEBUF_SIZE);
    if (rb < 10) { close(fd); return 0; }
    t = p + rb;
    *t = '\0';

    sl = strlen(searchstring1);
    p = memchr(p, *searchstring1, rb);
    while (p != 0) {
      if (!memcmp(p, searchstring1, sl)) {
        write1(fpath, strlen(fpath)); write1("\n", 1);
        close(fd);
        return 1;
      }
      rb = t - p;
      ++p;
      p = memchr(p, *searchstring1, rb);
    }

    p = rbuf;
    rb = t - p;
    sl = strlen(searchstring2);
    p = memchr(p, *searchstring2, rb);
    while (p != 0) {
      if (!memcmp(p, searchstring2, sl)) {
        write1(fpath, strlen(fpath)); write1("\n", 1);
        close(fd);
        return 1;
      }
      rb = t - p;
      ++p;
      p = memchr(p, *searchstring2, rb);
    }

    p = rbuf;
    rb = t - p;
    sl = strlen(searchstring3);
    p = memchr(p, *searchstring3, rb);
    while (p != 0) {
      if (!memcmp(p, searchstring3, sl)) {
        write1(fpath, strlen(fpath)); write1("\n", 1);
        close(fd);
        return 1;
      }
      rb = t - p;
      ++p;
      p = memchr(p, *searchstring3, rb);
    }

    lseek(fd, 1 - sl, SEEK_CUR);
  }
}


int main() {
  _exit(ftw(".", &scan_file, 64));
}

